###############################################
# FILE: dom_lex.pat
# SUBJ: Domain-specific lexical processing.
# AUTH: AM
# CREATED: 28/May/02 22:50:45
# NOTE:	Looking at a domain of commands to a robot, etc.
###############################################

@CODE
G("hello") = 0;
@@CODE

@PATH _ROOT _TEXTZONE _par

# please
# At start of paragraph, etc.
# Need to check for things like "please me, whoa yeah..."
@POST
  S("tmp") = N(2);
  group(2,2,"_advl");
  pncopyvars(S("tmp"),N(2));
@RULES
_xNIL <-
	_xSTART
	please
	@@

# Start verb is usually imperative
@CHECK
  if (!N("verb",2))
    fail();
  if (vconj(N(2)) != "inf")
    fail();
@POST
  S("tmp") = N(2);
  group(2,2,"_verb");
  group(2,2,"_vg");
  pncopyvars(S("tmp"),N(2));
@RULES
_xNIL <-
	_xSTART
	_xALPHA
	_xWILD [one lookahead fail=(_verb _vg)]	# 12/08/02 AM.
	@@

# If not yet assigned...	# 06/03/02 AM.
@POST
  pncopyvars();
  single();
  S("sem") = "direction";
  S("glom left") = 1;
@RULES
_adv <-
	_xWILD [one match=(		# 06/03/02 AM.
		north east south west
		northeast southeast northwest southwest
		)] @@

# News headers.
_newsHead [layer=(_clause _sentence)] <-
	_xANY
	\, [s]
	_date [s]
	_acro [s]
	_dbldash [s]
	@@

# FBIS note.
_fbis [layer=(_clause _sentence)] <-
	\[ [s]
	fbis [s]
	_xWILD [max=5]
	text [s]
	\] [s]
	@@
