###############################################
# FILE: domain.pat
# SUBJ: comment here
# AUTH: Your Name Here
# CREATED: 09/Nov/01 16:43:18
# MODIFIED:
###############################################

@CODE
G("hello") = 0;
@@CODE

@PATH _ROOT _TEXTZONE _par

@POST
 S("rating") = -1;
 S("sem") = "unhappy";	# Normalize.
 single();
@RULES
# Fuzzy adjective noun thingies.
_adj <- not [s] happy [s] @@
_adj <- not [s] pleased [s] @@
_adj <- fed [s] up [s] @@
_adj <- _xWILD [one match=(
	unhappy plain bad worse worst
	poor dirty trying sloppy
	hard
	)] @@

# For ambiguous verb adj guys.
@POST
  N("rating") = -1;
  N("sem") = "disappoint";
  N("adj sem") = "unhappy";
@RULES
_xNIL <- _xWILD [one match=(
	disappointed
	)] @@

@POST
  S("rating") = 1;
  S("sem") = "happy";	# Normalize.
  single();
@RULES
_adj <- _xWILD [s one match=(
	happy pleased ecstatic thrilled content great fortunate
	grateful good better best
	super excellent wonderful superlative exceptional fine
	nice pleasant
	friendly # non-adj -ly word.
	helpful polite responsive
	beautiful
	professional courteous thoughtful prompt
	honest
	)] @@

@POST
  # If uninflected or -s, could be verb,adj,noun...
  S("rating") = -1;
  S("sem") = "estimate";
  single();
@RULES
_underestimate [layer=(_adj _noun _verb)] <-
	under [s]
	_xWHITE [s star]
	\- [s opt]
	_xWHITE [s star]
	_Vestimate [s]
	@@
_overestimate [layer=(_adj _noun _verb)] <-
	over [s]
	_xWHITE [s star]
	\- [s opt]
	_xWHITE [s star]
	_Vestimate [s]
	@@

@POST
  S("sem") = "buyer";
  single();
@RULES
# Assumption.
_buyer [layer=(_noun)] <- _xWILD [s one match=(
	_proSubj homeowner buyer buyers us)] @@

@POST
  S("sem") = "house";	# Semantics in tree. # 11/28/01 AM.
  single();
@RULES
_house [layer=(_noun)] <- _xWILD [s one match=(
	home house building
	)] @@

# Concept of the home builder.
@POST
  S("sem") = "builder";
  single();
@RULES
_builder [layer=(_noun)] <- _xWILD [s one match=(
    _company
	you
	builder builders homebuilder homebuilders
	)] @@

@POST
  S("sem") = "sales";
  single();
@RULES
_sales [layer=(_noun)] <- sales @@

@POST
  S("sem") = "person";
  single();
@RULES
_person [layer=(_noun)] <- _xWILD [one match=(
	person people man men woman women
	staff
	)] @@

@POST
  S("sem") = "interior";
  S("interior") = 1;
  single();
@RULES
_interior [layer=(_adj)] <- interior @@
@POST
  S("sem") = "exterior";
  S("exterior") = 1;
  single();
@RULES
_exterior [layer=(_adj)] <- exterior @@

# House parts....
@POST
  S("sem") = "bathroom";
  S("interior") = 1;
  S("bathroom") = 1;
  single();
@RULES
_bathroom [layer=(_noun)] <- _xWILD [s one match=(
	bathroom bathrooms bath baths toilet toilets
	)] @@

@POST
  S("sem") = "kitchen";
  S("interior") = 1;
  S("kitchen") = 1;
  single();
@RULES
_kitchen [layer=(_noun)] <- _xWILD [s one match=(
	kitchen stove refrigerator
	kitchens stoves refrigerators
	)] @@

@POST
  S("sem") = "stairs";
  S("interior") = 1;
  single();
@RULES
_stairs [layer=(_noun)] <- _xWILD [s one match=(
	stair stairs stairway stairways steps
	)] @@

@POST
  S("sem") = "garage";
  S("interior") = 1;
  single();
@RULES
_garage [layer=(_noun)] <- _xWILD [s one match=(
	garage garages carport carports
	)] @@

# Doing this a different way now.
@POST
  N("sem") = "flooring";
  #noop();
@RULES
_xNIL <- _xWILD [s one match=(
	flooring floor floors
	carpet carpets carpeting carpetry
	)] @@

@POST
  N("sem") = "appliance";
  #noop();
@RULES
_xNIL <- _xWILD [s one match=(
	appliance appliances
	refrigerator refrigerators
	oven ovens
	microwave microwaves
	dishwasher dishwashers
	
	)] @@

@POST
  S("sem") = "appliance";
  single();
@RULES
_appliance [layer=(_noun)] <-
	trash [s]
	_xWHITE [s star]
	_xWILD [s one match=(compactor compactors)]
	@@
_appliance [layer=(_noun)] <-
	garbage [s]
	_xWHITE [s star]
	_xWILD [s one match=(disposal disposals)]
	@@

@POST
  N("sem") = "windows/doors";
  #noop()
@RULES
_xNIL <- _xWILD [s one match=(
	window windows
	door doors
	shutter shutters
	hinge hinges	# Ambiguous...
	handle handles	# Ambiguous
	)] @@

@POST
  N("sem") = "electrical/gas";
  #noop()
@RULES
_xNIL <- _xWILD [s one match=(
	electrical
	gas
	wiring
	)] @@

@POST
  S("sem") = "air cond/heat";
  single();
@RULES
_aircondheat [layer=(_noun)] <-
	duct [s]
	_xWHITE [s star]
	work [s]
	@@

_aircondheat [layer=(_noun)] <-
	water [s]
	_xWHITE [s star]
	_xWILD [s one match=(heater heaters heating)]
	@@

_aircondheat [layer=(_noun)] <-
	central [s opt]
	_xWHITE [s star]
	air [s]
	_xWHITE [s star]
	_xWILD [s one match=(
		conditioner conditioners conditioning unit units
		)] @@
	
@POST
  N("sem") = "air cond/heat";
  #noop();
@RULES
_xNIL <- _xWILD [s one match=(
	heating heater heaters
	duct ducts ducting
	)] @@

@POST
  S("sem") = "plumbing/water";
  single();
@RULES
_plumbing [layer=(_noun)] <-
	_xWILD [s one match=(pipe septic)]
	_xWHITE [s star]
	_xWILD [s one match=(work service services)]
	@@

@POST
  N("sem") = "plumbing/water";
  #noop();
@RULES
_xNIL <- _xWILD [s one match=(
	plumbing
	water
	)] @@

@POST
   N("sem") = "fireplace";
@RULES
_xNIL <- _xWILD [s one match=(
	fireplace fireplaces
	mantle mantles
	chimney chimneys
	)] @@

@POST
  N("sem") = "exterior";	# Outside items, really.
@RULES
_xNIL <- _xWILD [s one match=(
	landscaping
	fence fences fencing
	pool pools
	grading
	)] @@

@POST
  S("sem") = "clubhouse";
  single();
@RULES
_clubhouse [layer=(_noun)] <-
	_xWILD [s opt match=(community neighborhood)]
	_xWHITE [s star]
	club [s]
	_xWHITE [s star]
	_xWILD [s opt match=(house houses)]
	@@
_clubhouse [layer=(_noun)] <-
	_xWILD [s one match=(community neighborhood)]
	_xWHITE [s star]
	_xWILD [s one match=(center centers centre centres)]
	@@

@POST
  N("sem") = "clubhouse";
  #noop();
@RULES
_xNIL <- _xWILD [s one match=(
	clubhouse clubhouses
	)] @@

@POST
  N("sem") = "community";
  #noop();
@RULES
_xNIL <- _xWILD [s one match=(
	community communities
	neighborhood neighborhoods
	neighbor neighbors
	school schools
	)] @@

@POST
  N("sem") = "warranty";
  N("dom") = "warranty";	# Flag a domain concept.
@RULES
_xNIL <- warranty @@

##################

@RULES
#VERBS
@POST
  S("sem") = "close";
  single();
@RULES
_Vclose [layer=(_verb)] <-
	_xWILD [s one match=(close closed closing closes)]
	@@

@POST
  S("sem") = "representative";
  single();
@RULES
_Nrepresentative [layer=(_noun)] <- _xWILD [s one match=(
	representative representatives )] @@

@POST
  S("sem") = "deck";
  single();
@RULES
_Ndeck [layer=(_noun)] <- _xWILD [s one match=(
	deck decks decking )] @@
@POST
  S("sem") = "shelf";
  single();
@RULES
_Nshelf [layer=(_noun)] <- _xWILD [s one match=(
	shelf shelfs shelves )] @@

@POST
  S("sem") = "schedule";
  single();
@RULES
_Nschedule [layer=(_noun)] <- _xWILD [s one match=(
	schedule schedules )] @@

@POST
  S("sem") = "construction";
  single();
@RULES
_Nconstruction [layer=(_noun)] <- _xWILD [s one match=(
	construction work workmanship )] @@

@POST
	N("rating") = -1;
	# noop();
@RULES
_xNIL <- _xWILD [s one match=(
	_Nrush _Vrush
	)] @@
