###############################################
# FILE: init.pat
# SUBJ: Initializations for analyzer.
# AUTH: AM
# CREATED: 10/Nov/01 11:20:34
# MODIFIED:
###############################################

@CODE

### Hand-built kb command file!	# 05/30/02 AM.
### Note: To edit this file in VisualText and have it read
### by the analyzer, go to the KB Editor and delete the
### concept named 'ontology'.

# Compute path to user-editable ontology file.
G("ontology file") =
	G("$apppath")	# Base directory, e.g., C:\apps
	+ "\\data\\ontology.kb";

G("ontology") = findconcept(findroot(),"ontology");
if (!G("ontology"))
  {
  take(G("ontology file"));
  G("ontology") = findconcept(findroot(),"ontology");
  }

G("oldout") = "oldout.txt";	# 06/25/02 AM.
G("out") = "output.txt";	# 08/07/02 AM.
#  G("out") = "events.txt";

# If running inside VisualText, output to a file.
# Else, output to a buffer. (For example...)
#if (interactive())
#   G("out") = "output.txt";
#else
#  G("out") = cbuf();

G("verbose") = "verbose.txt";	# 06/22/02 AM.

# Output date and time to show that the output is live.
G("out") << "[" << today() << "]\n";

# If filename is "abc.txt", then $input head fetches "abc".
G("input filename") = G("$inputhead");

# For simplicity, assuming filename heads are unique.
# More complex schemes can be used, eg, based on directory
# names also.  The NLP++ function unpackdirs() may be of use.
G("unique fname") = G("input filename");

# Really, should traverse text to determine if all chars are
# uppercase.  Could also look for regions that are all uppercase
# versus mixed case.
G("allcaps") = 1;

# Threshold percent confidence.
G("threshold") = 70;

G("time anaphora") = 0; # Don't need to resolve time of events.

# If zoning a complex text format.
G("zoning") = 1;

# If plain text as opposed to HTML, XML or other format.
# NOTE: The format_ck pass automatically sets this.  To
# override, disable that pass.
# TODO: If some other format, set this variable as needed.
G("plain text") = 1;

# If printing out noun phrase file.
G("dump nps") = 1;

# If doing verbose or debug processing.
G("debugging") = 1;

# If handling/cleaning up messy input.
# eg, where line boundaries are a mess.
# eg, text from a pdf2txt converter.
G("messy") = 0;	# 03/18/02 AM.

# Flag that we've looked up alphabetics in dictionary.
G("lookupalpha") = 0;	# 03/20/02 AM.

# Phrase counting task.  If collecting phrases in kb across
# multiple documents.  Assuming for simplicity that a batch
# run will be done across a given folder, so that the
# NLP++ batchstart() function can be used to wipe out the
# results of a prior run.
# May want to designate some dummy input file name to signal
# the END of the batch run, as the analyzer has no way of
# knowing, otherwise.  Or can keep running totals.
G("TASK: Count Phrases Multi") = 0;

# Embed tags in output text.
G("xml recursive") = 1;
G("NP") = 1;
G("NOUN") = 0;

#### Initialize some general semantic handling in KB.
seminit();	# See semfuns pass.

@@CODE
