###############################################
# FILE: l_fnword.pat
# SUBJ: comment here
# AUTH: AM
# CREATED: 13/Apr/02 22:53:59
# MODIFIED:
###############################################

@CODE
if (!G("zoning"))
  exitpass();
@@CODE

@NODES _LINE

@POST
  ++X("func words");
  pncopyvars();
  single();
@RULES
_proSubj [layer=(_pro)] <- _xWILD [one match=(
	I we he she they
	)] @@
_proPoss [layer=(_pro)] <- _xWILD [s one match=(
	our my your his their its)] @@
_proObj [layer=(_proSubj _pro)] <- you [s] @@
_proObj [layer=(_pro)] <- _xWILD [s one match=(
	me him them us
	)] @@

# Lone "it".
@POST
  ++X("func words");
  pncopyvars(1);
  S("sem") = "it";
  S("don't splice") = 1;
  singler(1,1);
@RULES
_pro [layer=(_noun _np)] <-
  it [s]
  _xWILD [s one lookahead match=(_xWHITE _xPUNCT _xALPHA)
     except=( \' )]
  @@

@POST
  ++X("func words");
  pncopyvars();
  single();
@RULES
_proObj [layer=(_proPoss _pro)] <- her @@
_pro <- _xWILD [one match=(
	mine ours yours his hers theirs
	)] @@

_proObj [layer=(_pro)] <- _xWILD [one match=(	# 06/02/02 AM.
	myself yourself himself herself itself ourselves
	yourselves themselves
	)] @@

##### VERB "TO BE" #####
@POST
  ++X("func words");
  pncopyvars();
  S("inf") = 1;
  S("sem") = "be";
  S("stem") = "be";
  single();
@RULES
_be [layer=(_verb)] <- be @@

@POST
  ++X("func words");
  pncopyvars();
  S("-en") = 1;
  S("sem") = "be";
  S("stem") = "be";
  single();
@RULES
_be [layer=(_verb)] <- been @@

@POST
  ++X("func words");
  pncopyvars();
  S("person") = "1";
  S("number") = "singular";
  S("tense") = "present";
  S("sem") = "be";
  S("stem") = "be";
  single();
@RULES
_be [layer=(_verb)] <- am @@

@POST
  ++X("func words");
  pncopyvars();
  S("person") = "2s-123p";
  S("number") = "2s-123p";
  S("tense") = "present";
  S("sem") = "be";
  S("stem") = "be";
  single();
@RULES
_be [layer=(_verb)] <- are @@

@POST
  ++X("func words");
  pncopyvars();
  S("person") = "13s";
  S("number") = "singular";
  S("tense") = "past";
  S("-ed") = 1;
  S("sem") = "be";
  S("stem") = "be";
  single();
@RULES
_be [layer=(_verb)] <- was @@

@POST
  ++X("func words");
  pncopyvars();
  S("person") = "2s-123p";
  S("number") = "2s-123p";
  S("tense") = "past";
  S("-ed") = 1;
  S("sem") = "be";
  S("stem") = "be";
  single();
@RULES
_be [layer=(_verb)] <- were @@

@POST
  ++X("func words");
  pncopyvars();
  S("person") = "3";
  S("number") = "singular";
  S("tense") = "present";
  S("-s") = 1;
  S("sem") = "be";
  S("stem") = "be";
  single();
@RULES
_be [layer=(_verb)] <- is @@

@POST
  ++X("func words");
  S("number") = "any";
  single();
@RULES
_det <- the [s] @@
_det <- _xWILD [s one match=(
	any some)] @@

@POST
  ++X("func words");
  S("number") = "singular";
  single();
@RULES
_det <- _xWILD [s one match=(a an each every)] @@
_det [layer=(_fnword)] <- this @@

@POST
  ++X("func words");
  S("number") = "plural";
  single();
@RULES
_det <- _xWILD [s one match=(all)] @@
_det [layer=(_fnword)] <- _xWILD [one match=(these those)] @@
_fnword <- both @@

@POST
  ++X("func words");
  single();
@RULES
_fnword [layer=(_np)] <- there @@

# Ambiguous - can also be a verb, etc.
_fnword <- while @@

# Supposedly a conjunction, but prob more global than "and".
_fnword <- unless @@

# Special phrase separation properties.
# fnword except where shown to be a verb infinitive.
_fnword <- please @@

@POST
  ++X("func words");
  S("neg") = 1;
  single();
@RULES
_det <- no @@

@POST
  ++X("func words");
  single();
@RULES
# Treating this first and foremost as English fn word.
_fnword <- whose @@	# 02/26/02 AM.

_fnword <- then @@	# 05/23/02 AM.

# Except can be a verb, conj, prep.
_fnword <- except @@

# "Adverbs" that premodify adjectives.
@POST
  ++X("func words");
  single();
@RULES
_premod <- _xWILD [s one match=(
	very extremely totally wildly highly
	quite rather fairly
	considerably
	most least
	)] @@

# Doesn't increase degree.
@POST
  ++X("func words");
  single();
@RULES
_premod <- slightly @@

@POST
  ++X("func words");
  single();
@RULES
_modal <- _xWILD [s one match=(
	will would can could may might shall should ought
	must
	)] @@

@POST
  ++X("func words");
  pncopyvars();
  S("inf") = 1;
  S("sem") = "have";
  single();
@RULES
_have [layer=(_verb)] <- have @@
@POST
  ++X("func words");
  pncopyvars();
  S("-s") = 1;
  S("sem") = "have";
  single();
@RULES
_have [layer=(_verb)] <- has @@
@POST
  ++X("func words");
  pncopyvars();
  S("-ing") = 1;
  S("sem") = "have";
  single();
@RULES
_have [layer=(_verb)] <- having @@
@POST
  # Note that -en is idiomatic. "I've been had".
  ++X("func words");
  pncopyvars();
  S("-edn") = 1;
  S("sem") = "have";
  single();
@RULES
_have [layer=(_verb)] <- had @@

@POST
  ++X("func words");
  pncopyvars();
  S("inf") = 1;
  S("sem") = "do";
  single();
@RULES
_do [layer=(_modal _verb)] <- do @@

@POST
  ++X("func words");
  pncopyvars();
  S("-s") = 1;
  S("sem") = "do";
  S("stem") = "do";
  single();
@RULES
_do [layer=(_modal _verb)] <- does @@

@POST
  ++X("func words");
  pncopyvars();
  S("-ing") = 1;
  S("sem") = "do";
  S("stem") = "do";
  single();
@RULES
_do [layer=(_modal _verb)] <- doing @@

@POST
  ++X("func words");
  pncopyvars();
  S("-ed") = 1;
  S("sem") = "do";
  S("stem") = "do";
  single();
@RULES
_do [layer=(_modal _verb)] <- did @@

@POST
  ++X("func words");
  pncopyvars();
  S("-en") = 1;
  S("sem") = "do";
  S("stem") = "do";
  single();
@RULES
_do [layer=(_modal _verb)] <- done @@

@POST
  ++X("func words");
  S("neg") = 1;	# Negative.
  single();
@RULES
_neg [layer=(_adv)] <- _xWILD [s one match=(
	not never
	)] @@

# idiom: per capita.
@POST
  single();
@RULES
_adv [layer=_adj] <- per [s] _xWHITE [s star] capita [s] @@
_adv <- at [s] _xWHITE [s star] _xWILD [s one match=(most least)] @@

@RULES
_adj <-
	unaccounted [s]
	_xWHITE [s star]
	for [s]
	@@

@POST
  ++X("func words");
  single();
@RULES
_prep <-
	because [s]
	_xWHITE [s star]
	of [s]
	@@
_prep <-
	_xWILD [s one match=(according due owing prior as)]
	_xWHITE [s star]
	to [s]
	@@

_prep <-
	in [s]
	_xWHITE [s star]
	_xWILD [s one match=(keeping accordance)]
	_xWHITE [s star]
	with [s]
	@@

_adv <-
	_xWILD [s one match=(as when where if)]
	_xWHITE [s star]
	appropriate [s] @@

_prep <-
	in [s] _xWHITE [s star] addition [s] _xWHITE [s star] to [s]
	@@

_prep <- such [s] _xWHITE [s star] as [s] @@

# "for up to 2 days"
_prep <- for [s] _xWHITE [s star] up [s] _xWHITE [s star] to [s] @@

_prep <- along [s] _xWHITE [s star] with [s] @@
_prep <- as [s] _xWHITE [s star] for [s] @@
_prep <- as [s] _xWHITE [s star] of [s] @@
_prep <- away [s] _xWHITE [s star] from [s] @@
_prep <- except [s] _xWHITE [s star] for [s] @@
_prep <- out [s] _xWHITE [s star] of [s] @@
_prep <- up [s] _xWHITE [s star] to [s] @@
_prep <- by [s] _xWHITE [s star] means [s] _xWHITE [s star] of [s] @@
_prep <- in [s] _xWHITE [s star] comparison [s] _xWHITE [s star] with [s] @@
_prep <- in [s] _xWHITE [s star] front [s] _xWHITE [s star] of [s] @@
_prep <- in [s] _xWHITE [s star] relation [s] _xWHITE [s star] to [s] @@
_prep <- on [s] _xWHITE [s star] top [s] _xWHITE [s star] of [s] @@
_fnword <- because @@

_prep <-
	so [s]
	_xWHITE [s star]
	as [s]
	_xWHITE [s star]
	not [s opt]
	_xWHITE [s star]
	to [s]
	@@

@POST
  ++X("func words");
  pncopyvars();
  single();
@RULES
_prep <- _xWILD [s one match=(
	about above after along around
#	as	# 08/01/02 AM.
	at
	before below beside between
	beyond
	by
	down
	during # acts like prep.
	for from
	in into
	near
	of off on over
	out	# adv etc.
	past
	since # fnword....
	till through to
	throughout
	under until up
	underneath
	with without within
	despite
	per upon
	)] @@

# Special preps.
_prep <- _xWILD [s one match=(
	regarding concerning)] @@

_conj <- _xWILD [s one match=(and or nor)] @@

# Misc function words.
_fnword <- _xWILD [s one match=(
	that whatever whenever wherever
    if than
	whether
	thus
	although though
	whereupon whereas
	either neither so
	)] @@

_fnword [layer=_adv] <- therefore [s] @@

# Conjunction type thingy.
_fnword <- but @@

_noun <- something @@
_noun <- everything @@
_noun <- everyone @@

@POST
  ++X("func words");
  S("neg") = 1;
  single();
@RULES
_noun <- nothing @@

@POST
  ++X("func words");
  single();
@RULES

# Other is tricky too.
# _adj [layer=(_fnword)] <- other @@
_fnword <- other [s] _xWHITE [s star] than [s] @@
_adj <- other @@

_fnword [layer=(_adj _adv)] <-
	only @@	# adj, adv, who knows what else.
	
_fnword [layer=(_adv)] <- _xWILD [s one match=(
	however such)] @@

_fnword [layer=(_whword)] <- _xWILD [s one match=(
	what when where how why
	which
	)] @@

_fnword [layer=(_whword _proSubj _proObj _pro)] <- who @@
_fnword [layer=(_whword _proObj _pro)] <- whom @@

@POST
  ++X("func words");
  S("temporal") = 1;
  S("unit") = "dy";
  S("sem") = "date";	# 07/18/02 AM.
  single();
@RULES
_day [layer=(_time _noun)] <-
	_xWILD [s one match=(day days)]
	@@

