###############################################
# FILE: l_seg10.pat
# SUBJ: Segment or "chunk" per line of text.
# AUTH: AM
# CREATED: 17/Apr/02 15:28:09
# MODIFIED:
###############################################

@CODE
G("hello") = 0;
@@CODE

@NODES _LINE

# Specialized lines.
@POST
  xrename("_FIELDLINE");
@RULES
_xNIL <-
	_fieldhd
	_phone
	@@
_xNIL <-
	_fieldhd
	_xANY [plus gp=_value]
	_xEND
	@@

# Sentinels
@POST
  noop();
@RULES
_xNIL <- _xWILD [s one match=(
	_np _vg _pp _seg
	)] @@
###

@RULES
_np <-
	_xWILD [s one match=(_pro) except=(_proPoss)]
	@@

@POST
  singler(2,3);
@RULES
_np <-
	_xWILD [s one match=(_prep)]
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s plus match=(_xNUM _num _quan)]
	_xWILD [s one lookahead match=(_qEOS)]
	@@

@CHECK
  if (!N("adv",2))
    fail();
@POST
  group(2,2,"_adv");
@RULES
_xNIL <-
	_xWILD [s one lookahead match=(_prep)]
	_xALPHA
	_xWILD [s one match=(_xNUM _num _quan)]
	@@

@POST
  group(1,1,"_np");
@RULES
_xNIL <-
	_xWILD [s one match=(this these those) except=(_np _nps)]
	_vg [s lookahead]
	@@

@POST
  S("seg type") = "np";
# NLP++ bug here...
#  if (N("val",1))
#   if (N("val",1) > 0)
    S("val") = N("val",1);
  singler(1,3);
@RULES
_seg <-
	_xWILD [s one match=(_det _quan _num _xNUM _noun _proPoss
		_premod)
		except=(_np _nps _fnword)]
	_xWILD [s star match=(_adv _advl)] # 03/16/02 AM.
	_xWILD [plus match=(_xALPHA _noun _adj _xNUM _num _quan
		_acro	# 05/02/02 AM.
#		_verb	# 05/02/02 AM.
		_aposS)]
	_xWILD [s one lookahead match=(
		_seg
		_modal _have _be _vg
		_verb	# Trying this.	# 05/02/02 AM.
		_advl _adv
		_prep
		_conj
		_xPUNCT
		_fnword
		_pro
		_det # 03/16/02 AM.
		_dbldash _qEOS
		)]
	@@

# PER LINE MATCHING VERSION ONLY.
_seg <-
	_xWILD [s one match=(_det _quan _num _xNUM _noun _proPoss
		_premod)
		except=(_np _nps _fnword)]
	_xWILD [s star match=(_adv _advl)] # 03/16/02 AM.
	_xWILD [plus match=(_xALPHA _noun _adj _xNUM _num _quan
#		_verb	# 05/02/02 AM.
		_aposS)]
	_xEND
	@@

#@POST
#  S("seg type") = "vg";
#  singler(1,2);
#@RULES
#_seg <-
#   _xWILD [s one match=(_modal _have _be)]
#   _xWILD [s opt]
#   _xWILD [s one lookahead match=(
#	 _det _quan _num _xNUM
#	 _adj
#	 _advl _adv
#	 _prep
#	 _conj
#	 _xPUNCT
#	 _fnword
#	 _pro
#	 )]
#	@@

# Otherwise, collect a blob of nodes.
# Doing this for glommed sentence.
# 05/01/02 AM.
@POST
  S("seg type") = "alpha";
  G("tmp") = lasteltnode(1);
  pncopyvars(G("tmp"));
  single();
@RULES
_seg <-
	_xWILD [s min=2 fail=(
		_det
#		_quan _num _xNUM
		_vg _modal _have _be
		_verb	# Trying this.	# 05/02/02 AM.
		_prep _premod
		_conj
		_xPUNCT
		_fnword
		_pro
		_whtSEP _whtINDENT
		_dbldash
		_np _seg
		_adv _advl
		_fieldhd
		)]
	@@

@POST
  S("seg type") = "alpha";
  # Get the head of the phrase.
  G("tmp") = lasteltnode(2);
  G("nm") = pnname(G("tmp"));
  pncopyvars(G("tmp")); # Copy to suggested node.
  if (pnvar(G("tmp"),"pos num") == 1)	# Unambiguous
    {
	if (G("nm") == "_adj")
		S("seg type") = "adj";
	else if (G("nm") == "_adjs")
		S("seg type") = "adjs";
	else if (G("nm") == "_noun")
		S("seg type") = "np";
	}
  single();
@RULES
_seg <-
  _xWILD [s opt match=(_proPoss this these those)]
  _xWILD [s min=2
  	match=(
  		_adj _adjs _noun _aposS
#		_verb	# 05/02/02 AM.
		_xALPHA
  		)
	except=(_seg _np _vg _modal _have _be
		_verb # 05/02/02 AM.
		_det _quan _num _xNUM
		_prep _conj _fnword
		_adv _advl _pro
	)]
	@@

@RULES
_seg <-
  _xWILD [s one match=(_proPoss this these those)]
  _noun
  @@


# Convert lone noun to np.
#@RULES
#_np <- 
#	_xWILD [s one match=(_noun) except=(_np _nps _seg)]
#	@@


@POST
  S("seg type") = "vg";
  single();
@RULES
_seg <- _verb [s] @@

# If it's a lone alpha, convert to alpha seg.
@POST
  S("seg type") = "alpha";
  pncopyvars();
  single();
@RULES
_seg <- _xALPHA @@

@RULES
_np <-
	_xWILD [s one match=(all most some few each)]
	of [s]
	_np
	@@

@POST
  group(2,2,"_np");
@RULES
_xNIL <-
	_prep [s]
	_xNUM
	_xWILD [s one lookahead match=(_qEOS)]
	@@

@CHECK
  S("text") = strtolower(N("$text",2));
  if (strendswith(S("text"),"ing")
   || strendswith(S("text"),"ed")
   || N("-edn", 2)
   || suffix(S("text"),"s") )
    fail();
@POST
  group(2,2,"_vg");
@RULES
_xNIL <-
	to [s]
	_verb
	@@

# to pump green slime
@CHECK
	if (!N("verb",2))
		fail();
	if (!N("adj",3) && !N("noun",3))
		fail();
	S("text") = strtolower(N("$text",2));
	if (suffix(S("text"),"s") ||
		suffix(S("text"),"ing") ||
		suffix(S("text"),"ed") ||
		N("-edn",2) )
		fail();
@POST
  group(2,2,"_verb");
  group(2,2,"_vg");
@RULES
_xNIL <-
	to [s]
	_xALPHA
	_xALPHA [lookahead]
	@@
@CHECK
	if (!N("verb",2))
		fail();
	S("text") = strtolower(N("$text",2));
	if (suffix(S("text"),"s") ||
		suffix(S("text"),"ing") ||
		suffix(S("text"),"ed") ||
		N("-edn",2) )
		fail();
@POST
  group(2,2,"_verb");
  group(2,2,"_vg");
@RULES
_xNIL <-
	to [s]
	_xALPHA
	_xWILD [one lookahead match=(
		_det _quan _xNUM _num _adj _adjs _np _prep)]
	@@



