###############################################
# FILE: lex_misc.pat
# SUBJ: comment here
# AUTH: AM
# CREATED: 26/Feb/02 08:20:08
# MODIFIED:
###############################################

@CODE
G("hello") = 0;
@@CODE

@PATH _ROOT _TEXTZONE _par

# Sentinels.	# 09/04/02 AM.
@POST
  noop();
@RULES
_xNIL <-
	_xWILD [s one match=(_modal _have _be)]
	@@


# alpha free
# overly specific rule, perhaps.  Assumes idioms handled
# earlier.
@CHECK
  if (!N("noun",2))
    fail();
@POST
  S("tmp") = N(3);
  group(3,3,"_adj");
  pncopyvars(S("tmp"),N(3));
  S("tmp") = N(2);
  group(2,2,"_noun");
  group(2,2,"_np");
  pncopyvars(S("tmp"),N(2));
@RULES
_xNIL <-
	_xWILD [s one match=(_qEOS)]
	_xALPHA
	free
	_xWILD [s one lookahead match=(_prep _conj _adv)]
	@@


# each of det
@RULES
_det <-
	each [s]
	of [s]
	_det [s]
	@@

# Conditions for 'using' to be a prep.
@POST
  group(2,2,"_prep");
@RULES
_xNIL <-
	_xWILD [s one match=(_noun _numslashnum _dashnum)]
	using [s]
	@@

# Conditions for 'otherwise' to be an adv.
@POST
  group(3,3,"_adv");
@RULES
_xNIL <-
  _xWILD [s one match=(_modal _have _be _verb)]
  _xWILD [s star match=(_adv _advl)]
  otherwise [s]
  @@


# Hi conf conditions on 'both'.
# May want some lookahead for higher conf.
@CHECK
  if (!N("noun",3))
  	fail();
  S("txt") = strtolower(N("$text",3));
  S("stem") = stem(S("txt"));	# More reliable than suffix().
  if (!strendswith(S("txt"),"s")
   || S("stem") == S("txt") )
    fail();
@POST
  group(3,3,"_noun");
  group(2,3,"_np");
@RULES
_xNIL <-
	_prep [s]
	both [s]
	_xALPHA
	@@

# det alpha alpha
# Going to use domain semantics here, if present.
# 06/03/02 AM.
@CHECK
  if (!N("adv",3))
    fail();
  S("stem") = N("stem",3);
  if (!S("stem"))
    S("stem") = N("$text",3);
  S("stem") = strtolower(S("stem"));
  S("word con") = dictfindword(S("stem"));
  if (!S("word con"))
    fail();
  S("val1") = conval(S("word con"),"advsem");
  if (!S("val1"))
    fail();
  # Else, found adverb semantics in this domain.
  # Check for noun also.
  S("val2") = conval(S("word con"),"nounsem");
  if (S("val2"))
    fail();
@POST
  # Get domain semantics.
  S("par") = up(S("val1"));
  N("sem",3) = conceptname(S("par"));

  S("tmp") = N(3);
  group(3,3,"_adv");
  pncopyvars(S("tmp"),N(3));
  S("tmp") = N(2);
  group(2,2,"_noun");
  group(1,2,"_np");
  pncopyvars(S("tmp"),N(1));
  N("det first",1) = 1;
@RULES
_xNIL <-
	_xWILD [s one match=(a the)]
	_xALPHA [lookahead]
	_xALPHA
	@@

# det noun
@CHECK
  if (!N("noun",2) && !N("adj",2))
  	fail();
  if (N("noun",2) && N("adj",2))
    fail();		# 08/01/02 AM.
@POST
  S("tmp") = N(2);
  if (N("adj",2))
  	group(2,2,"_adj");
  else
    group(2,2,"_noun");
  pncopyvars(S("tmp"),N(2));
@RULES
_xNIL <-
	_xWILD [s one match=(a the)]
	_xWILD [s one fail=(_np _vg _noun _verb _adj _adv)]
	@@

# prep date
# prep year
@POST
#  G("verbose") << "HERE: " << phrasetext() << "\n";
  group(2,3,"_np");
  N("sem",2) = "date";	# Collect semantics.	# 05/02/02 AM.
@RULES
_xNIL <-
	_xWILD [s one match=(_prep)]
	_xWILD [s star match=(_adv _advl)]
	_xWILD [one match=(_xNUM _num _quan)]
	_xWILD [s one lookahead match=(_conj \, )]
	@@

@POST
  pncopyvars(3);
  singler(2,3);
@RULES
_num <-
	_xWILD [s one match=(including)]
	_xWILD [s one match=(about around)]
	_xWILD [s one match=(_xNUM _num)]
	@@

# If it's in a seg already.
@POST
  pnrename(N(2),"_adv"); # renaming _prep.
  N("id",2) = "lex_misc 01";	# for tracing.
  listadd(3,2,"false");
@RULES
_xNIL <-
	_xWILD [s one match=(including)]
	_xWILD [s one match=(about around)]
	_xWILD [one match=(_np _nps _seg)]
	@@

@POST
  group(4,4,"_noun");
  N("quoted",4);
@RULES
_xNIL <-
	_det [s]
	_xWILD [one]
	\"
	_xWILD
	\"
	@@


@POST
  group(1,1,"_pro");
  group(1,1,"_np");
@RULES
_xNIL <-
	one [s]
	_prep [s]
	@@

@POST
  S("tmp") = N(1);
  group(1,1,"_verb");
  pncopyvars(S("tmp"),N(1));
@RULES
_xNIL <-
	need
	to [s lookahead]
	_xWILD [s one match=(_be _vg)]
	@@

# DASH PHRASE
@CHECK
  if (N("-edn",3) || N("-en",3))
    succeed();
  if (N("non-ed",3))
    fail();
  G("tmp") = strtolower(N("$text",3));
#  if (!suffix(G("tmp"),"ed"))
  if (!strendswith(G("tmp"),"ed")
   && !N("-edn",3) )
  	fail();
@POST
  group(1,1,"_np");	# So it will be detected by np searches.
  single();
@RULES
_adj <-
	_noun [s]
	\- [s trigger]
	_verb [s]
	@@

# "deposits creates"
@CHECK
  if (!N("noun",1))
    fail();
  S("tmp") = strtolower(N("$text",2));
  if (!strendswith(S("tmp"),"s"))
    fail();
@POST
  S("tmp") = N(2);
  group(2,2,"_vg");
  pncopyvars(S("tmp"),N(2));
  S("tmp") = N(1);
  group(1,1,"_noun");
  pncopyvars(S("tmp"),N(1));
@RULES
_xNIL <-
	_xALPHA
	_xWILD [s one match=(_verb) except=(_modal _have _be _vg)]
	@@

# precludes impact
# verb alpha
@CHECK
 if (N("pos num",2) != 2)
 	fail();
 if (!N("verb",2) || !N("noun",2))
 	fail();
 S("text") = strtolower(N("$text",1));
 if (!suffix(S("text"),"s"))
 	fail();
 # Need check for helping verbs here.
@POST
  group(2,2,"_noun");
@RULES
_xNIL <-
	_verb
	_xALPHA
	@@

# verb alpha
@CHECK
  if (!N("adj",2))
    fail();
  S("tmp") = N("stem",1);
  if (!S("tmp"))
    S("tmp") = strtolower(N("$text",1));
  S("cop") = findconceptwithparent(S("tmp"),"verbsem","copula");
  if (!S("cop"))
    fail();
@POST
  S("n2") = N(2);
  group(2,2,"_adj");
  pncopyvars(S("n2"),N(2));
  N("copula",1) = 1;
@RULES
_xNIL <-
	_verb
	_xALPHA
	@@

@CHECK
  if (!N("noun",2))
    fail();
@POST
  group(2,2,"_noun");
@RULES
_xNIL <-
	this [s]
	_xALPHA
	@@

# by waste
# by eating
#@POST
#  S("text") = strtolower(N("$text",2));
#  if (suffix(S("text"),"ing"))
#    pnrename(N(2),"_vg");
#  else if (N("noun",2) || (N("seg type",2) == "np"))
#	pnrename(N(2),"_np");
#@RULES
#_xNIL <-
#	by [s]
#	_seg
#	@@
#
# owing to blank.
#@CHECK
#  if (!N("noun",2) && (N("seg type",2) != "np"))
#  	fail();
#  if (N("adj",2) || N("adv",2))
#  	fail();
#@POST
#  pnrename(N(2),"_np");
#@RULES
#_xNIL <-
#	_xWILD [s one match=(_prep) except=(by to)]
#	_seg
#	@@
#

###########
## NAMES
###########
# Throwing some name handling around here.
# An _xLETTER would be useful.
@POST
  singler(1,3);
@RULES
_name [layer=_noun] <-
	_title [s]
	_abbrev [s]
	_xALPHA
	_xWILD [s one lookahead match=(_acro _adv _advl)]
	@@

@PRE
<2,2> length(1);	# Check for a letter (length 1 alpha).
@POST
 singler(1,4);
@RULES
_name [layer=_noun] <-
	_title [s]
	_xALPHA [s] # Should be a letter.
	\. [s]
	_xALPHA
	_xWILD [s one lookahead match=(_acro _adv _advl)]
	@@

@PRE
<1,1> length(1);
@CHECK
  if (!N("unknown",3))
  	fail();
@POST
  singler(1,3);
@RULES
_name [layer=_noun] <-
	_xALPHA [s]
	\. [s]
	_xALPHA
	_xWILD [one lookahead fail=(_xALPHA)]
	@@

# in verb
@CHECK
  if (!N("verb",2))
    fail();
@POST
  group(2,2,"_adj");
@RULES
_xNIL <-
	_xWILD [s one match=(in)]
	_xALPHA
	@@

# alpha conj alpha
# verb conj verb
# Demand agreement.
@CHECK
  if (!N("verb",1) || !N("verb",3))
    fail();
  S("vc1") = vconj(N(1));
  S("vc2") = vconj(N(3));
  if (S("vc1") != S("vc2"))
    fail();
  if (!N("noun",1) && !N("noun",3))
    succeed();
  if (S("vc1") != "-ing"
   && S("vc1") != "-edn"
   && S("vc1") != "-en"
   && S("vc1") != "-ed" )
     fail();
@POST
  group(3,3,"_verb");
  group(1,1,"_verb");
@RULES
_xNIL <-
  _xALPHA
  _conj [s]
  _xALPHA
  @@

@POST
  S("n") = N(2);
  S("tmp") = pnname(N(4));
  if (S("tmp") == "_verb")	# Fix. 09/05/02 AM.
    {
	group(2,2,"_verb");
	pncopyvars(S("n"),N(2));
	}
@RULES
_xNIL <-
  _xWILD [s one match=(_conj _fnword _xPUNCT)]
  _xALPHA
  _conj
  _xANY
  @@

# noun subject to the noun
@POST
  group(2,3,"_prep");
@RULES
_xNIL <-
	_noun
	subject [s]
	to [s]
#	_xWILD [s one lookahead match=(_det _quan _adj _noun)]
	@@

@CHECK
  if (!N("noun",1))
    fail();
@POST
  group(2,3,"_prep");
@RULES
_xNIL <-
	_xALPHA
	subject [s]
	to [s]
	_xWILD [s one match=(_det _quan _adj _noun)]
	@@

# Some idioms.
@POST
  group(1,1,"_verb");
@RULES
_xNIL <-
	_xWILD [one match=(belonging)]
	to [s lookahead]
	@@

# prep that
# In many cases, nulls the function word meaning of that.
@POST
  group(2,2,"_det"); # todo: get rid of _fnword in tree.
  setbase(2,"true");
@RULES
_xNIL <-
	_xWILD [s one match=(_prep) except=(so)]
	that [s]
	@@

# num ven noun
@CHECK
  if (!N("noun",3))
  	fail();
  if !ven(N(2))
    fail();
@POST
  "dict.txt" << "'" << N("$text",2) << "' => ADJ" << "\n";
  splice(2,2);
@RULES
_xNIL <-
	_xWILD [one match=(_num _quan _xNUM)]
	_verb
	_xALPHA
	@@

# Resolving some advs.
# Note: 'immediately' == 'as soon as' chiefly British.
@POST
  if (N("adv",2))
    group(2,2,"_adv");
@RULES
_xNIL <-
	_xWILD [s one match=(_modal _have _be)]
	_xALPHA
	_xWILD [s one match=(_modal _have _be _verb)]
	@@

@POST
  group(1,1,"_adv");
@RULES
_xNIL <-
	immediately [s]
	_xWILD [s one lookahead fail=(
		_det _quan _adj _noun _np _nps)]
	@@

# alpha alpha
@CHECK
  if (!N("adv",2))
    fail();
  if (!N("verb",3))
    fail();
@POST
  group(2,2,"_adv");
@RULES
_xNIL <-
	_xWILD [s one match=(_modal _have _be)]
	_xALPHA
	_xALPHA [lookahead]
	@@


@POST
  group(1,1,"_np");
@RULES
_xNIL <-
	one [s]
	_xWILD [s one lookahead match=(_modal _have _be _verb)]
	@@

# even fnword
@POST
  group(1,1,"_adv");
@RULES
_xNIL <-
	even [s]
	_xWILD [s one lookahead match=(_fnword)]
	@@

# ving ving
# alpha alpha
@CHECK
  if (!N("verb",1) || !N("verb",2))
    fail();
  if (vconj(N(1)) != "-ing")
    fail();
  if (vconj(N(2)) != "-ing")
    fail();
@POST
  group(2,2,"_verb");
  group(2,2,"_vg");
@RULES
_xNIL <-
	_xALPHA
	_xALPHA
	_xWILD [s one lookahead match=(_prep not _adj _adv)]
	@@

# announced yesterday
# alpha alpha
@CHECK
  if (N("sem",2) != "date")
    fail();
  S("vconj") = vconj(N(1));
  if (S("vconj") != "-edn"
   && S("vconj") != "-en")
    fail();
@POST
  S("tmp") = N(2);
  group(2,2,"_np");
  pncopyvars(S("tmp"),N(2));
  S("tmp") = N(1);
  group(1,1,"_verb");
  pncopyvars(S("tmp"),N(1));
@RULES
_xNIL <-
	_xALPHA
	_xALPHA
	@@

# alpha alpha
# copula adj
@CHECK
  if (!N("verb",1))
    fail();
  if (!N("adj",2))
    fail();
  S("tmp") = N("stem",1);
  if (!S("tmp"))
    S("tmp") = strtolower(N("$text",1));
  S("cop") = findconceptwithparent(S("tmp"),"verbsem","copula");
  if (!S("cop"))
    fail();
@POST
  S("n2") = N(2);
  group(2,2,"_adj");
  pncopyvars(S("n2"),N(2));
  S("n1") = N(1);
  group(1,1,"_verb");
  pncopyvars(S("n1"),N(1));
  N("copula",1) = 1;
@RULES
_xNIL <-
	_xALPHA
	_xALPHA
	@@


# not later
@CHECK
  if (!N("adj",2))
  	fail();
  if (N("verb",2) || N("noun",2))
    fail();
@POST
  group(2,2,"_adj");
@RULES
_xNIL <-
	not [s]
	_xALPHA
	@@

# nonarticle A.
@POST
  group(1,1,"_noun");
  setbase(1,"true");
@RULES
_xNIL <-
  a [s]
  _xWILD [s one lookahead match=( \, _prep _verb _modal)]
  @@


# verb alpha det
@CHECK
  if (!N("adv",2))
    fail();
@POST
  group(2,2,"_adv");
@RULES
_xNIL <-
	_verb [s]
	_xALPHA
	_det [s]
	@@

# if adj
@POST
  singler(1,3);
@RULES
_advl <-
	_xWILD [s one match=(if when)]
	_xWILD [s star match=(_adv _advl)]
	_adj
	_xWILD [s one lookahead match=( \, _qEOS )]
	@@

@CHECK
  if (!N("adj",3))
    fail();
@POST
  singler(1,3);
@RULES
_advl <-
	_xWILD [s one match=(if when)]
	_xWILD [s star match=(_adv _advl)]
	_xALPHA
	_xWILD [s one lookahead match=( \, _qEOS )]
	@@

# alpha num alpha
@CHECK
  if (!N("noun",3))
    fail();
  S("num") = num(N("$text",2));
  S("plu") = plural(N(3));
  if (S("num") > 1 && !S("plu"))
  	fail();
  if (S("num") == 1 && S("plu"))
  	fail();
@POST
  S("tmp") = N(3);
  group(2,2,"_quan");
  if (S("plu"))
    {
	group(3,3,"_noun");
	group(2,3,"_np");
	pncopyvars(S("tmp"),N(2));
	}
@RULES
_xNIL <-
	_xALPHA
	_xNUM
	_xALPHA
	@@

# Starting to use preferences, which may be changed dynamically.
@CHECK
  if (N("verb") < 90)
    fail();
@POST
  S("tmp") = N(2);
  group(2,2,"_verb");
  pncopyvars(S("tmp"),N(2));
  # probably imperative...
@RULES
_xNIL <-
	_xSTART
	_xALPHA
	@@

# prep conj alpha
# up and left
@CHECK
  if (!N("adv",2) || !N("adv",4))
    fail();
@POST
  pnrename(N(2),"_adv");
  N("id",2) = "lex_misc 02";	# for tracing.
  S("tmp") = N(4);
  group(4,4,"_adv");
  pncopyvars(S("tmp"),N(4));
@RULES
_xNIL <-
    _xWILD [s one match=(_verb _adv)]
	_prep
	_conj
	_xALPHA
	@@

# that unk det
# Could also be an adverb, etc....
@CHECK
  if (!N("unknown",2))
  	fail();
@POST
	S("tmp") = N(2);
	group(2,2,"_verb");
	group(2,2,"_vg");
	pncopyvars(S("tmp"),N(2));
@RULES
_xNIL <-
	_fnword [s]
	_xALPHA
	_det [s]
	@@

@POST
  S("tmp") = N(1);
  group(1,1,"_pro");
  pncopyvars(S("tmp"),N(1));
@RULES
_xNIL <-
	several
	_xWILD [s one lookahead match=(of)]
	@@

# alpha prep
@POST
  S("tmp") = N(1);
  if (N("adj",1) && N("verb",1))
    {
	S("conj") = vconj(N(1));
	if (S("conj") != "inf")
	  {
	  group(1,1,"_verb");
	  pncopyvars(S("tmp"),N(1));
	  }
	}
@RULES
_xNIL <-
	_xALPHA
	_prep [s lookahead]
	@@

# adv alpha
@CHECK
  S("vconj") = vconj(N(2));
  if (S("vconj") != "-s")
    fail();
  "goes.txt" << "here\n";
@POST
  group(2,2,"_verb");
@RULES
_xNIL <-
	_adv [s]
	_xALPHA
	@@

# idiomatic: nothing (very) adj
@CHECK
  if (!N("adj",3))
    fail();
@POST
 pncopyvars(1);
 S("adj node") = N(3);
 single();
@RULES
_np <-
	nothing [s]
	very [s star]
	_xWILD [one match=(_adj _xALPHA)]
	@@
