###############################################
# FILE: lex_unambig.pat
# SUBJ: Unambiguous dictionary words.
# AUTH: AM
# CREATED: 09/Dec/01 00:05:40
# NOTE: Integrated Dave's English Lexicon with AM generic
#	parser.  Current pass is the first to use this data.
###############################################

@CODE
if (G("zoning"))
  exitpass();
@@CODE

@PATH _ROOT _TEXTZONE _par

# Special cases...
# directly is almost always an adv, not a conj.
@RULES
_adv <- directly @@

# pro verb
# his baked brie
@CHECK
  if (!N("verb",2))
    fail();
  S("tmp") = vconj(N(2));
  if (S("tmp") != "-en"
   && S("tmp") != "-edn")
    fail();
@POST
  S("tmp") = N(2);
  group(2,2,"_adj");
  pncopyvars(S("tmp"),N(2));
@RULES
_xNIL <-
	_proPoss [s]
	_xALPHA
	@@
	

@POST
  singler(1,1);
@RULES
_np <-
	_xWILD [s one match=(both) except=(_np)]
	of [s lookahead]
	@@

@POST
  pncopyvars(2);
  if (N("adj sem",2))
    S("sem") = N("adj sem",2);
  else if (!N("sem",2))
    {
	S("tmp") = strtolower(N("$text",2));
    S("stem") = stem(S("tmp"));
    if (S("stem"))
       S("sem") = S("stem");
    else
       S("sem") = S("tmp");
    }
  single();
@RULES
_adj <-
  _premod [s]
  _xALPHA
  @@
  
@POST
#	if (N("wordcon"))  # Known word.
#	  {
#	  }
#	else	# UNKNOWN WORD. # 03/16/02 AM.
#	   {
#	   # Need to do better, but it's a start. # 03/16/02 AM.
#	   # Need to handle misspellings, mumbles, new words, names.
#	   N("noun") = 1;	# DEFAULT is noun.
#	   G("pos") = "_noun";
#	   N("pos num") = 1;
#	   N("stem") = S("tmp"); # Don't do stemming.
#	   }
#
	if (N("pos num") == 1)	# UNAMBIGUOUS PART OF SPEECH.
		{
		if (N("pos"))
		   {
		   G("node") = N(1);
		   group(1,1,N("pos"));
		   pncopyvars(G("node"),N(1));	# 12/14/01 AM.
		   if (!N("sem"))	# 01/01/02 AM.
		     {
			 if (N("text"))
			   S("tmp") = N("text");
			 else
			   S("tmp") = strtolower(N("$text"));
		     S("stem") = stem(S("tmp"));
		     if (S("stem"))
		        N("sem") = S("stem");
		     else
		        N("sem") = S("tmp");
			 }
		   }
		}
	# STARTING TO USE CONFIDENCE, FREQUENCY.	# 06/02/02 AM.
	else if (N("verb") >= 90)
	  {
      S("tmp") = N(1);
      group(1,1,"_verb");
      pncopyvars(S("tmp"),N(1));
	  }
	else if (N("adv") >= 90)
	  {
      S("tmp") = N(1);
      group(1,1,"_adv");
      pncopyvars(S("tmp"),N(1));
	  }

@RULES
_xNIL <-
	_xALPHA	# Uncharacterized, unreduced.
	@@

# Todo: Need to flag "retokenized" things.	# 09/04/02 AM.
# Retokenized stuff.
#_xNIL <-				# 09/04/02 AM.
#	_xANY
#	@@
