###############################################
# FILE: lines_messy.pat
# SUBJ: Segment possibly messy lines.
# AUTH: AM
# CREATED: 20/Mar/02 10:11:30
# NOTE:	For example, a messy line might have a word with hyphen
#	at the end, or have a period slip over to the start of next
#	line.
###############################################

@CODE
if (!G("zoning")
 || !G("plain text")	# 07/14/02 AM.
 || !G("messy"))
	exitpass();

@@CODE

@PATH _ROOT

@RULES

_BLANKLINE <-
    _xWILD [min=0 max=0 matches=(\ \t \r)] ### (1)
    \n ### (2)
    @@

_RULELINE <-
	_xWHITE [s star]
	_xPUNCT [min=2 max=0]
    _xWILD [min=0 max=0 matches=(\ \t \r)]
    \n
	@@

# Grabbing lines where the period spills into next line.
@POST
  ++G("spilled period");	# Gather evidence for period spill.
  single();
@RULES
_LINE [unsealed] <-
    _xWILD [min=0 max=0 fails=(\r \n
		_TEXTZONE _LINE _RULELINE _BLANKLINE)] ### (1)
    \n ### (2)
	_xWHITE [star]
	\.
	_xWHITE [star]
    @@

@RULES
_LINE [unsealed] <-
    _xWILD [min=0 max=0 fails=(\r \n
		_TEXTZONE _LINE _RULELINE _BLANKLINE)] ### (1)
    \n ### (2)
    @@

@RULES
_LINE [unsealed] <-
    _xWILD [min=0 max=0 fails=(\r \n
		_TEXTZONE _LINE _RULELINE _BLANKLINE)] ### (1)
    _xWILD [opt match=(_xEND)] ### (2)
    @@

