###############################################
# FILE: lookup_clean.pat
# SUBJ: Lookup alphabetics in "clean" texts.
# AUTH: AM
# CREATED: 20/Mar/02 12:12:30
# NOTE: Just characterizing alphas, for now.
###############################################

@CODE
if (G("messy"))
  exitpass();
G("lookupalpha") = 1;	# Flag that we've done lookup.
@@CODE

@NODES _LINE

# Sentinel.
@POST
  noop();
@RULES
_xNIL <-
	_xALPHA
	\-
	_xALPHA
	\-
	_xALPHA
	_xWILD [star match=( \- _xALPHA)]
	@@

#####
## CORRECTIONS TO DICTIONARY HERE.
#####

# 'past' is a prep.

# 'go' missing from dict!
@POST
  N("pos num") = 3;
  N("verb") = 95;	# Putting in some preferences!
  N("noun") = 4;
  N("adj") = 1;
  N("stem") = "go";
  N("pos") = "_verb";
@RULES
_xNIL <- go @@

# 'seek' listed as noun in dict, but can't corroborate.
@POST
  N("pos num") = 1;
  N("verb") = 100;
  N("stem") = "seek";
  N("pos") = "_verb";
@RULES
_xNIL <- seek @@
_xNIL <- seeks @@

# resolving listed as noun, can't corroborate.
@POST
  N("pos num") = 1;
  N("verb") = 1;
  N("stem") = "resolve";
  N("pos") = "_verb";
@RULES
_xNIL <- resolving @@

@POST
  N("pos num") = 2;
  N("verb") = 1;
  N("adv") = 1;		# MISSING.
  N("stem") = "please";
  N("pos") = "_verb";
@RULES
_xNIL <- please @@

# To avoid mis-stemming.
@POST
  N("pos num") = 1;
  N("noun") = 1;
  N("stem") = "thing";
  N("sem") = "thing";
  N("pos") = "_noun";
@RULES
_xNIL <- thing @@

@POST
  N("pos num") = 1;
  N("adj") = 1;
  N("stem") = "unirradiated";
  N("pos") = "_adj";
@RULES
_xNIL <- unirradiated @@

@POST
  N("pos num") = 2;
  N("adj") = 1;		# MISSING.
  N("noun") = 1;
  N("stem") = "miotic";
  N("pos") = "_adj";
@RULES
_xNIL <- miotic @@

@POST
# BUG: "do" is listed only as a noun in the dictionary!
  N("pos num") = 2;
  N("verb") = 1;	# MISSING.
  N("noun") = 1;
  N("stem") = "do";
  N("pos") = "_verb";
@RULES
_xNIL <- do @@

@POST
  N("pos num") = 2;
  N("verb") = 1;
  N("noun") = 1;	# MISSING.
  N("stem") = "whale";
  N("pos") = "_noun";
@RULES
_xNIL <- whaling @@

@POST
  N("pos num") = 2;
  N("verb") = 1;
  N("noun") = 1;
  N("stem") = "reprocess";
  N("pos") = "_noun";
@RULES
_xNIL <- reprocessing @@

@POST
  S("pos num") = 2;
  S("verb") = 1;
  S("noun") = 1;
  S("text") = "cochair";
  S("stem") = "cochair";
  S("pos") = "_noun";
  single();
@RULES
cochair <-
	co [s]
	\- [s]
	chair [s]
	@@

@POST
  N("pos num") = 2;
  N("verb") = 1;
  N("noun") = 1;
  N("stem") = "cochair";
  N("pos") = "_noun";
@RULES
_xNIL <- cochair @@

# Stemmer incorrectly does improving => improv!
@POST
  N("pos num") = 2;
  N("verb") = 1;
  N("adj") = 1;
  N("stem") = "improve";
  N("pos") = "_verb";
@RULES
_xNIL <- improving @@
_xNIL <- improved @@

@POST
  N("pos num") = 1;
  N("verb") = 1;
  N("stem") = "locate";
  N("pos") = "_verb";
@RULES
_xNIL <- locating @@

@POST
  N("pos num") = 3;
  N("noun") = 1;
  N("adj") = 1;
  N("sem") = "direction";
  N("stem") = strtolower(N("$text"));
#  if (N("$length") == 1)
#    N("adv") = 50;	# confidence.
#  else
    N("adv") = 95;	# Ballworld domain.
@RULES
_xNIL <- _xWILD [one match=(
	n s e w
	ne se nw sw
	nne ene sse ese nnw wnw ssw wsw
	)] @@

#####
#####

# LOOKUP ALPHABETICS HERE.
# We're handling quirky ANSI chars that may be glommed onto
# a word, so may as well look up a word while we're at it,
# for efficiency.
# Todo: Need something that properly creates a new node, within
# the context of a rule match.  Need node for double-dash.
@POST
  N("lctext") = strtolower(N("$text"));

  # Look up in dictionary.
  lookupalpha(N("lctext"),N(1));
  
  # Todo: May want to look up elsewhere...
  if (!N("pos num"))	# Not in dictionary.
  	{
#	"unknown.txt" << N("lctext") << "\n";
	N("unknown") = 1;
	N("stem") = N("lctext");
	unknownword(N("lctext"),N(1));
	}
@RULES
_xNIL <- _xALPHA @@

