###############################################
# FILE: prec100.pat
# SUBJ: comment here
# AUTH: AM
# CREATED: 25/Jul/02 11:08:02
# MODIFIED:
###############################################

@CODE
G("hello") = 0;
@@CODE

@PATH _ROOT _TEXTZONE _par _sentence

# vg date that
# In general, date phrases are adverbial.
@CHECK
  if (N("sem",3) != "date")
    fail();
@POST
  S("tmp") = N(3);
  group(3,3,"_advl");
  pncopyvars(S("tmp"),N(3));
@RULES
_xNIL <-
	_vg
	_xWILD [s star match=(_adv _advl)]
	_np
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one lookahead match=(_fnword _qEOS)]
	@@

# seg advl vg
@POST
  if (N("seg nouns",1))
    {
	pnrename(N(1),"_np");
	N("id",1) = "prec100 sav";
	}
@RULES
_xNIL <-
	_seg
	_xWILD [s star lookahead match=(_adv _advl)]
	_vg
	@@

# Apposition.
# vg [advl] np , np [,] who
@POST
  pncopyvars(1);
  S("appositive np") = N(3);
  singler(1,4);
@RULES
_np <-
	_xWILD [s one match=(_np _nps)]
	\, [s]
	_xWILD [s one match=(_np _nps)]
	\, [s opt]
	_xWILD [s one lookahead match=(who whom)]
	@@

# I don't see much use for treating "ago" as an adjective.
@POST
  pncopyvars(1);
  S("rel time") = "ago";
  S("sem") = "date";	# If not there yet.
  single();
@RULES
_advl <-
	_np
	ago [s]
	@@

# Introducing more constrained instances...	# 09/21/02 AM.
# np conj np
@POST
  S("pn nps")[0] = N(2);
  S("pn nps")[1] = N(4);
  domcompose(N(2),N(4));
  singler(2,4);
@RULES
_nps <-
	_xWILD [s one match=(_prep _vg)]
	_xWILD [s one match=(_np _nps)]
	_conj [s]
	_xWILD [s one match=(_np _nps)]
	_xWILD [s one lookahead match=(\, _fnword)]
	@@

_nps <-
	_xWILD [s one match=(_vg)]
	_xWILD [s one match=(_np _nps)]
	_conj [s]
	_xWILD [s one match=(_np _nps)]
	_xWILD [s star lookahead match=(_adv _advl)]
	_qEOS [s]
	@@

# Strong semantic connection.
# np conj np
@CHECK
  if (N("sem",1) && N("sem",1) == N("sem",3))
    succeed();
  fail();
@POST
  S("pn nps")[0] = N(1);
  S("pn nps")[1] = N(3);
  domcompose(N(1),N(3));
  single();
@RULES
_nps <-
	_xWILD [s one match=(_np _nps)]
	_conj [s]
	_xWILD [s one match=(_np _nps)]
	@@
