###############################################
# FILE: qclause100.pat
# SUBJ: Traverse clauses in order
# AUTH: AM
# CREATED: 24/May/02 16:23:43
# MODIFIED:
###############################################

@CODE
"dump.txt"
	<< "\n"
	<< "[PASS qclause100: Semantic Traversal of Parse Tree.]\n\n";
@@CODE

@PATH _ROOT _TEXTZONE _par _sentence

@POST
  "clauses.txt" << phrasetext() << "\n\n";
  N("zone") = X("zone",2);
  clauseregister(N(1),X(4));

  # Traverse clause, registering its objects, etc.
  S("last np") = prevnp(X(4));
  clausetraverse(N(1),		# Current node.
  				 N(1),		# Current clause.
				 X(4));		# Current sentence.
  clauseresolve(N(1),X(4),S("last np"));
  X("clause",4) = N(1);
@RULES
_xNIL <-
	_clause
	@@

# Note: _complex and _advl may have clauses in them.

# Assume that complex has one or more clauses in it.
@POST
  N("zone") = X("zone",2);
  complextraverse(N(1),X(4));
@RULES
_xNIL <-
	_complex
	@@

# Handle only single clause in adverbial for now.
@POST
N("zone") = X("zone",2);
if (N("advl list"))	# List of adverbials.
  {
  advlshandle(N(1),X(4));
  }
#else if (N("clause") || N("clauses"))
# {
# "clauses.txt" << phrasetext() << "\n\n";
# if (N("clause"))
#   {
#   clauseregister(N("clause"),X(4));
#   S("last np") = prevnp(X(4));
#   clausetraverse(N("clause"),N("clause"),X(4));
#   clauseresolve(N("clause"),X(4),S("last np"));
#   X("clause",4) = N("clause");
#   }
# else if (N("clauses"))
#   {
#   S("count") = arraylength(N("clauses"));
#   S("ii") = 0;
#   while (S("ii") < S("count"))
#     {
#	 S("cls") = N("clauses")[S("ii")];
#     clauseregister(S("cls"),X(4));
#     S("last np") = prevnp(X(4));
#     clausetraverse(S("cls"),S("cls"),X(4));
#     clauseresolve(S("cls"),X(4),S("last np"));
#	 X("clause",4) = S("cls");
#	 ++S("ii");
#	 }
#   }
# }
#else
#  {
#  # Get object, perhaps semantic case, from pp.
#  # Can register to the current sentence at least.
#  # Could check if before, betwixt, after clauses.
#  if (N("pp"))	# Prepositional phrase
#    {
#	# Register adverbial as a kind of nearly empty clause.
#	advlregister(N(1),X(4));
#	
#	# Handle non-clause adverbials.
#	advltraverse(N(1),X(4));
#	}
#
#  }

# Not quite right.  Need to traverse and update each
# sub-adverbial...
if (N("nps"))
  # This looks dubious.... # 10/05/02 AM.
  pnreplaceval(X(4),"last np",N("nps")[0]);  # Reversed list...
else if (N("np"))
  pnreplaceval(X(4),"last np",N("np"));
@RULES
_xNIL <-
	_advl
	@@

# Handle some other stragglers here.  Treat a lone NP as an
# "event", semantically speaking.  May want to try to merge
# the NP posthumously with an NP inside a previous or
# subsequent clause.
@POST
  N("zone") = X("zone",2);
  N("pattern",1) = "np";	# "Clausal" pattern.
  clauseregister(N(1),X(4));
  S("last np") = prevnp(X(4));
  clausetraverse(N(1),		# Current node.
  				 N(1),		# Current clause.
				 X(4));		# Current sentence.
  newevent(N("kb concept",1),G("events"));
  clauseresolve(N(1),X(4),S("last np"));
  X("clause",4) = N(1);
@RULES
_xNIL <-
	_np
	@@
