###############################################
# FILE: qlines.pat
# SUBJ: Characterize lines.
# CREATED: 05/Aug/99 16:20:38
# WARN: 09/15/99 AM. NO MULTI-TOKEN PATTERNS SHOULD APPEAR BEFORE THIS
#       PASS. OR THE COUNTS WILL BE INCORRECT!!
###############################################

@NODES _LINE

@POST
	X("nwhite") = X("nwhite") + N("$length",1);		# 06/04/00 AM.
@RULES
_xNIL <- _xBLANK [s] @@

@POST
	# Some texts may have been glommed or retokenized.	# 03/20/02 AM.
	if (N("text"))
		S("text") = strtolower(N("text"));
	else
		S("text") = strtolower(N("$text"));
	S("len") = strlength(S("text"));

	X("nalpha") = X("nalpha") + S("len");	# 03/20/02 AM.
	++X("walpha");				# 06/04/00 AM.
	++G("walpha");	# Track alphas in text.	# 07/16/02 AM.
	# To save a pass, calc unknowns here.	# 01/30/02 AM.
	if (!spellword(S("text")))		# 03/20/02 AM.
	  ++X("nunknowns");				# 01/30/02 AM.
	X("end punct") = 0;
    X("end dash") = 0;
    X("end comma") = 0;
	
	# Look for a sloppy starts and ends of sentences, etc.
	if (N("det") || N("prep") || N("adj") || N("conj"))
	  {
	  X("sloppy end") = 1;	# Possibly needs continuation.
	  if (!N("adj"))
	    ++X("prose words");
	  }
	else
	  X("sloppy end") = 0;
	if (!X("start"))
	  {
	  X("start") = 1;
	  if (N("conj") || N("verb") || N("prep"))
	    X("sloppy start") = 1;
	  }
@RULES

_xNIL <- _xALPHA [s] @@

@POST
    X("end punct") = 0;
    X("end dash") = 0;
    X("end comma") = 0;
	X("sloppy end") = 0;
	X("nnum") = X("nnum") + N("$length",1);		# 06/04/00 AM.
	++X("wnum");				# 06/04/00 AM.
	if (!X("start"))
	   X("start") = 1;
@RULES
_xNIL <- _xNUM [s] @@

@POST
    X("end punct") = 0;
    X("end dash") = 0;
    X("end comma") = 0;
	X("sloppy end") = 0;
	X("npunct") = X("npunct") + N("$length",1);	# 06/04/00 AM.
	S("text") = N("$text");
	if (S("text") == "."
	 || S("text") == ":"
	 || S("text") == "!"
	 || S("text") == "?"
	 || S("text") == ";"
	 )
     X("end punct") = 1;	# Flag end-of-sentence punctuation.
   else if (S("text") == "-")
     X("end dash") = 1;
   else if (S("text") == ","
    || S("text") == "/")	# Treat as comma.
     X("end comma") = 1;
   if (!X("start"))
      {
      X("start") = 1;
	  if (S("text") == "(")
	    X("sloppy start") = 1;
	  }
@RULES
_xNIL <- _xPUNCT [s] @@

@POST
  noop();
@RULES
_xNIL <-
	_xWILD [one match=( \r \n )]
	@@

# Any stragglers are assumed to have been "retokenized"
# or otherwise reduced.
@POST
  X("end punct") = 0;
  X("end dash") = 0;
  X("end comma") = 0;
  X("sloppy end") = 0;
  if (N("text"))
    S("text") = N("text");
  else
    S("text") = N("$text");
  if (N("tok type") == "alpha")
  	{
	++X("retoks");	# Good indicator of prose line.
	S("len") = strlength(S("text"));

	X("nalpha") = X("nalpha") + S("len");	# 03/20/02 AM.
	++X("walpha");
	++G("walpha");	# 07/16/02 AM.
	# To save a pass, calc unknowns here.
	if (!spellword(S("text")))		# 03/20/02 AM.
	  ++X("nunknowns");

	# Look for a sloppy starts and ends of sentences, etc.
	if (N("det") || N("prep") || N("adj") || N("conj"))
	  {
	  X("sloppy end") = 1;	# Possibly needs continuation.
	  if (!N("adj"))
	    ++X("prose words");
	  }
	if (!X("start"))
	  {
	  if (N("conj") || N("verb") || N("prep"))
	    X("sloppy start") = 1;
	  }
	}
  else
    {
    if (S("text") == "."
     || S("text") == ":"
     || S("text") == "!"
     || S("text") == "?"
     || S("text") == ";"
     )
     X("end punct") = 1;	# Flag end-of-sentence punctuation.
    else if (S("text") == "-")
     X("end dash") = 1;
    else if (S("text") == ","
	 || S("text") == "/")	# Treat as comma.
     X("end comma") = 1;
    }
  if (!X("start"))
    {
    X("start") = 1;
	if (S("text") == "(")
	  X("sloppy start") = 1;
	}
@RULES
_xNIL <-
	_xANY
	@@
