###############################################
# FILE: qlines3.pat
# SUBJ: More line characterizations
# AUTH: AM
# CREATED: 22/Mar/02 12:21:12
# NOTE:	Looking for text lists "1. xxx", "2. xxx" etc.
# TODO: Things like 1.3.2 , a. b. c. (a) (b) (c).
###############################################

@CODE
G("num list") = 0;	# If there's a num list in the text.
# Assume one list, for simplicity, for now.

G("max num") = 0;	# Max list number.
@@CODE

@NODES _LINE

@POST
  S("num") = num(N("$text",3));
  if (S("num") == (G("max num") + 1)
   || S("num") == 1)
  	{
	G("max num") = S("num");
	X("num list") = S("num");	# Keep line count.
	if (S("num") == 2)	# At least a list of two.
		G("num list") = 1;	# Accept that there's a list.
	if (S("num") > G("max num"))
	  G("max num") = S("num");
	}
  noop();
@RULES
_xNIL <-
	_xSTART
	_xWILD [star match=(_xWHITE _whtINDENT)]
	_xNUM
	\.
	_xWILD [plus match=(_xWHITE _whtSEP)]
	@@

# Looking for some line-oriented patterns.
@POST
  ++X("field line");
  single();
@RULES
_phonehd [layer=(_fieldhd)]  <-
	_xSTART
	_xWILD [star match=(_xWHITE _whtINDENT)]
	_xWILD [one match=(phone telephone fax)]
	\:
	_xWHITE [star]
	@@
_emailhd [layer=(_fieldhd)]  <-
	_xSTART
	_xWILD [star match=(_xWHITE _whtINDENT)]
	_xWILD [one match=(email)]
	\:
	_xWHITE [star]
	@@
_emailhd [layer=(_fieldhd)]  <-
	_xSTART
	_xWILD [star match=(_xWHITE _whtINDENT)]
	e
	\-
	mail
	\:
	_xWHITE [star]
	@@
_urlhd [layer=(_fieldhd)] <-
	_xSTART
	_xWILD [star match=(_xWHITE _whtINDENT)]
	_xWILD [one match=(internet web homepage url)]
	\:
	_xWHITE [star]
	@@

_fieldhd <-
	_xSTART
	_xWILD [star match=(_xWHITE _whtINDENT)]
	_xALPHA
	_xWHITE [star]
	_xALPHA [opt]
	_xWHITE [star]
	_xALPHA [opt]
	\:
	_xWHITE [star]
	@@
