###############################################
# FILE: seg100.pat
# SUBJ: Resolve segments by clause patterns.
# AUTH: AM
# CREATED: 23/Apr/02 16:29:05
# MODIFIED:
###############################################

@CODE
G("hello") = 0;
@@CODE

@PATH _ROOT _TEXTZONE _par _sentence

# which np
@POST
  N("wh start",3) = 1;
  listadd(3,2,"false");
@RULES
_xNIL <-
	_xSTART
	which [s]
	_np
	@@

@POST
  listadd(2,1,"false");
@RULES
_xNIL <-
	both [s]
	_xWILD [s one match=(_np _nps)]
	@@

@POST
  pnrename(N(5),"_np");
@RULES
_xNIL <-
	_np
	_vg
	_np
	_prep
	_seg
	_xWILD [one lookahead match=(_qEOS)]
	@@

@POST
  pnrename(N(5),"_np");
@RULES
_xNIL <-
	_xSTART
	_prep
	_np
	\, [opt]
	_seg [lookahead]
	_vg
	@@

@POST
  S("tmp") = N(3);
  S("dom") = N("dom slot",3);
  group(2,3,"_advl");
  N("pp",2) = 1;
  N("pn nps",2)[0] = S("tmp");
  N("nps",2) = S("tmp");
  if (S("dom"))
    N("dom slot",2) = S("dom");
@RULES
_xNIL <-
	_xSTART
	_prep
	_np
	\, [opt]
	@@

# Could be an adj, adv, etc.  Need more corroboration by
# looking inside segments to say "possible np".
@POST
  # if copula, and seg looks like adj...
  if (N("seg len",3) == 1 && N("seg adjs",3))
    pnrename(N(3),"_adj");
  else
    pnrename(N(3),"_np");
@RULES
_xNIL <-
	_np
	_vg
	_seg
	_xWILD [s one lookahead match=(that _prep)]
	@@

# find it necessary to...
# Need logic for both np and adj.
@CHECK
  if (!N("adj",3))
  	fail();
@POST
  pnrename(N(3),"_adj");
@RULES
_xNIL <-
	_vg
	_np
	_seg
	to [s]
	@@

@CHECK
  if (!N("unknown",2))
    fail();
@POST
  pnrename(N(2),"_np");
@RULES
_xNIL <-
	_vg
	_seg
	@@

@POST
  # Eg, "sign of life" => "life".
  if (N("sem",1) == "sign" || N("stem",1) == "sign")
    pncopyvars(3);
  else
    pncopyvars(1);
  domcompose(N(1),N(3));
  single();
@RULES
_np <-
	_xWILD [one match=(_np _nps)]
	of [s]
	_xWILD [one match=(_np _nps)]
	@@

# the storage of waste in cans
@POST
  pncopyvars(2);
  domcompose(N(2),N(4));
  singler(2,4);
@RULES
_np <-
	_xWILD [s one match=( _xPUNCT)]
	_np
	_prep
	_np
	_xWILD [s one lookahead match=(_vg _xPUNCT)]
	@@


@POST
  pncopyvars(3);
  S("prep stem") = N("stem",2);
  singlex(2,3);
@RULES
_advl <-
	\, [s]
	_prep
	_xWILD [s one match=(_np _nps)]
	\, [s]
	@@

@CHECK
  if (!N("adj",3))
  	fail();
@POST
  pnrename(N(3),"_adj");
  singler(1,3);
@RULES
_adj <-
	_adj
	_conj
	_seg
	_xWILD [s one lookahead match=(_xPUNCT)]
	@@

# Some grammar critique here.
@POST
  "critique.txt" << "Simplify: of how to" << "\n";
  excise(2,3);
@RULES
_xNIL <-
	_np
	of [s]
	how [s]
	to [s]
	@@

@POST
  S("stems")[0] = N("stem",1);
  S("stems")[1] = N("stem",3);
  single();
@RULES
_advl <-
	_xWILD [s one match=(_adv _advl)]
	_conj [s]
	_xWILD [s one match=(_adv _advl)]
	@@

@CHECK
  if (!N("noun",3) && N("seg type",3) != "np")
  	fail();
@POST
  pnrename(N(3),"_np");
@RULES
_xNIL <-
	_xWILD [s one match=(_vg)]
	\, [s opt]
	_seg
	_xWILD [s one lookahead match=(_prep)]
	@@

@CHECK
  if (!N("quoted",2))
    fail();
@RULES
_np <-
	_np
	_np
	@@

# Looking at a bit of parallel construction.
# ving np, not ving np.
@CHECK
# So won't infinite loop here.
  if (N("seg split 1st verb",1))
    fail();
@POST
  if (N("seg 1st vconj",1) == "-ing"
   && N("seg 1st vconj",4) == "-ing")
     N("seg split 1st verb",1) = 1;
  noop();
@RULES
_xNIL <-
	_seg
	\,
	_xWILD [s star match=(_adv _advl)]
	_vg
	_np
	@@

# seg np
@POST
  if (N("verb",3) || N("seg type",3) == "vg")
    pnrename(N(3),"_vg");
@RULES
_xNIL <-
	_xWILD [s one match=(_conj)]
	_xWILD [s star match=(_adv _advl)]
	_seg
	_np
	_xWILD [s one lookahead match=(_qEOS)]
	@@

# np copula adj to np
# object is close to object
# Todo: check for copula, else it could be:
# "John eats close to the book".
# (Which is similar, conceptually speaking.)

@POST
  N("glom right",1) = 1;
  N("glom left",9) = 1;
  S("tmp") = N(3);
  S("adj stem") = N("stem",5);
  group(3,7,"_vg");
  pncopyvars(S("tmp"),N(3));
  N("pattern",3) = "vjp";
  N("adj stem",3) = S("adj stem");
  N("particle stem",3) = "to";
@RULES
_xNIL <-
	_np
	_xWILD [s star match=(_adv _advl)]
	_vg
	_xWILD [s star match=(_adv _advl)]
	_adj
	_xWILD [s star match=(_adv _advl)]
	to [s]
	_xWILD [s star match=(_adv _advl)]
	_np
	@@

# conj seg np vg
@CHECK
  if (!npseg(N(2)))
    fail();
@POST
  pnrename(N(2),"_np");
  N("id",2) = "seg100 010";
@RULES
_xNIL <-
	_conj [s]
	_seg
	_xWILD [s one lookahead match=(_np _nps)]
	_vg
	@@


# conj seg np
@CHECK
  if (!N("verb",2))
    fail();
@POST
  pnrename(N(2),"_vg");
  N("id",2) = "seg100 010";
@RULES
_xNIL <-
	_conj [s]
	_seg
	_xWILD [s one lookahead match=(_np _nps)]
	@@

# np seg prep
@CHECK
  if (N("seg len",2) != 1)
    fail();
  if (!N("verb",2))
    fail();
@POST
  pnrename(N(2),"_vg");
  N("id",2) = "seg100 011";
@RULES
_xNIL <-
	_xWILD [s one match=(_np _nps)]
	_seg
	_prep [s lookahead]
	@@

# vg seg
# make sure
@CHECK
  if (N("seg len",2) != 1)
  	fail();
  if (N("pos num",2) == 2
   && N("adj",2)
   && N("adv",2))
    succeed();
  fail();
@POST
  pnrename(N(2),"_adj");
  N("id",2) = "seg100 012";
@RULES
_xNIL <-
	_vg [s]
	_seg
	@@
