###############################################
# FILE: seg20.pat
# SUBJ: Look at segments in context.
# AUTH: AM
# CREATED: 14/May/02 15:17:22
# NOTE:	Need a segment characterization pass prior to this.
# (That could really be inside segment collection, but @PRE
# region doesn't support NLP++ code yet).
###############################################

@CODE
G("hello") = 0;
@@CODE

@PATH _ROOT _TEXTZONE _par

@POST
  if (npseg(N(2)) && npseg(N(4)) )
    {
	pnrename(N(2),"_np");
	pnrename(N(4),"_np");
	}
@RULES
_xNIL <-
	_vg
	_seg
	_conj
	_seg
	_xWILD [s one lookahead match=(_prep)]
	@@

# that ving noun and noun be
@POST
# If verb is "are" or "were", don't split.
# If verb is "is", split.
if (N("number",5) == "singular"
 && N("seg 1st verb",2) )
	{
	# Flag that initial verb is to be split off segment.
	N("seg split 1st verb",2) = 1;
	}
@RULES
_xNIL <-
	that [s]
	_seg
	_conj
	_xWILD [one match=(_noun _np _seg)]
	_be [s]
	@@

# np , and np
# Perhaps erroneous comma.
@CHECK
  if (!N("noun",4))
  	fail();
@POST
  pnrename(N(4),"_np");
@RULES
_xNIL <-
	_xWILD [one match=(_np _nps _noun)]
	\,
	_conj
	_seg
	_xWILD [s one lookahead match=(_prep)]
	@@

# was told that fuel
# vg that seg
@CHECK
  if (!N("noun",3))
  	fail();
@POST
  if (N("seg 1st vconj") != "-ing")
  	pnrename(N(3),"_np");
@RULES
_xNIL <-
	_vg
	that [s]
	_seg
	@@

@POST
  N("nosplit left",2) = 1;
  N("nodissolve",2) = 1;
  # Rather than the above, need to gather evidence,
  # confidence, etc.  Need to look inside and in context
  # around seg, then make a decision...
@RULES
_xNIL <-
	_xWILD [one match=(_verb _vg)]
	_seg
	_prep [s lookahead]
	@@

@POST
  N("nosplit left",2) = 1;
@RULES
_xNIL <-
	_xWILD [s one match=(
	  # _prep
      _verb _vg) except=(of)]
	_seg
	@@

# prep seg seg
@POST
  if (npseg(N(2)))
    pnrename(N(2),"_np");
@RULES
_xNIL <-
	_prep [s]
	_seg
	_seg [lookahead]
	@@

# seg seg
# Look at two segs next to each other.
# Criteria for not splitting 1st verb off seg.
@POST
  if ((N("det start",1) || N("seg type",1) == "np")
   && (N("det start",2) || N("seg type",2) == "np") )
    {
	if (N("seg last verb",1))
	  N("seg split last verb",1) = 1;
	else if (N("seg first verb",2))
	  N("seg split first verb",2) = 1;
	}
  else if (N("seg type",2) == "np")
    {
	if (N("seg verbs",1))
	  {
	  pnrename(N(1),"_vg");
	  N("id",1) = "seg20 01";
	  }
	}
  else if (N("seg type",1) == "vg")
    N("nosplit left",2) = 1;
  else if (N("seg type",2) == "vg")
    N("nosplit right",1) = 1;
@RULES
_xNIL <-
	_seg
	_seg [lookahead]
	@@

# seg eos
@POST
  # Should see if prior verb is a copula, etc.
  if (N("adv",1))
    pnrename(N(1),"_adv");
  N("eos") = 1;	# Ends a sentence.
@RULES
_xNIL <-
	_seg
	_qEOS
	@@

# seg than
# "no more than..."
# Todo: check COMPARATIVE adjs, like "greater", "happier", etc.
@CHECK
  if (!N("seg last adj",1))
    fail();
@POST
  pnrename(N(1),"_adj");
@RULES
_xNIL <-
	_seg
	than [s]
	@@

# conj seg np
# conj seg pro
@CHECK
  if (!N("seg last verb",2))
    fail();
@POST
  if (N("seg len") == 1)
    {
    pnrename(N(2),"_vg");
    N("id",2) = "seg20 02";
	}
  else
    N("seg split last verb",2) = 1;
@RULES
_xNIL <-
	_xWILD [s one match=(_conj)]
	_seg
	_proObj [s]
	@@

# fnword seg
@CHECK
  if (!N("seg last verb",2))
    fail();
@POST
  if (N("seg len") == 1)
    {
    pnrename(N(2),"_vg");
	N("id",2) = "seg20 03";
	}
  else
    N("seg split last verb",2) = 1;
@RULES
_xNIL <-
	_fnword [s]
	_seg
	_xWILD [s one lookahead match=(_qEOS _xEND)]
	@@

# Don't dissolve if can be a good np.
@POST
  N("nodissolve",5) = 1;
@RULES
_xNIL <-
	_np
	_xWILD [s opt match=(_verb _vg)]
	_adj
	_prep
	_seg
	_xWILD [s one lookahead match=(_qEOS)]
	@@

@POST
  N("right verb",1) = 1;
@RULES
_xNIL <-
	_seg
	_vg [s lookahead]
	@@
