###############################################
# FILE: seg200.pat
# SUBJ: Prepositionals etc.
# AUTH: AM
# CREATED: 25/Apr/02 09:55:49
# MODIFIED:
###############################################

@CODE
G("hello") = 0;
@@CODE

@PATH _ROOT _TEXTZONE _par _sentence

# A complex prep.
# prep such ... as
# for such noun as
@POST
  S("no particle") = 1;
  if (pnname(N(3)) == "_seg")
    pnrename(N(3),"_np");
  single();
@RULES
_fnword <-
	_prep
	such [s]
	_xANY
	as [s]
	@@


@RULES
_np <-
	_xWILD [s one match=(each all any)]
	of [s]
	_xWILD [s star match=(_adv _advl)]
	_np [s]
	@@

# Assumes complex noun phrases have been found, etc.
@POST
  S("pp") = 1;
  singler(2,4);
@RULES
_advl <-
	_xSTART
	_prep
	_xWILD [s star match=(_adv _advl)]
	_np
	_xWILD [s one lookahead match=( _xPUNCT _qEOS _np _nps \) 
		_fnword )]
	@@

@POST
  S("pp") = 1;
  singler(1,3);
@RULES
_advl <-
	_prep
	_xWILD [s star match=(_adv _advl)]
	_np
	_xEND
	@@

@CHECK
	if (N("unknown",3))
	  succeed();
	if (N("seg type",3) == "np")
	  succeed();
	if (N("noun",3) || N("seg nouns",3))
	  succeed();
	fail();
@POST
  S("pp") = 1;
  pnrename(N(3),"_np");
  singler(1,3);
@RULES
_advl <-
	_xWILD [one match=(_prep)]
	_xWILD [s star match=(_adv _advl)]
	_seg
	_xWILD [s one lookahead match=(_vg \, _qEOS \) _fnword
		_prep _np _nps _conj _advl _adv )]
	@@

@CHECK
	if (N("unknown",3))
	  succeed();
	if (N("seg type",3) == "np")
	  succeed();
	if (N("pos num",3) == 1 && N("noun",3))
	  succeed();
	fail();
@POST
  S("pp") = 1;
  pnrename(N(3),"_np");
  single();
@RULES
_advl <-
	_xWILD [one match=(_prep)]
	_xWILD [s star match=(_adv _advl)]
	_seg
	@@

@POST
  pncopyvars(4);
  if (N("stem",2))
    S("prep stem") = N("stem",2);
  S("pp") = 1;
  S("pn nps")[0] = N(4);	# 06/24/02 AM.
  S("nps") = N(4);
  S("clause") = N(4);
  singler(2,4);
@RULES
_advl <-
	_xWILD [one match=(_np _nps _vg)]
	_prep
	_xWILD [s star match=(_adv _advl)]
	_xWILD [one match=(_np _nps)]
	@@

@POST
 S("pp") = 1;
 if (N(2))
   domcompose(N(2),N(3));
 else
   pncopyvars(3);
 S("pn nps")[0] = S("nps") = N(3);	# 07/09/02 AM.
 if (N("eventive",3))
   {
   S("eventive") = 1;
   S("clause") = N(3);
   }
 singler(1,3);
@RULES
_advl <-
	_prep
	_xWILD [s star match=(_adv _advl)]
	_xWILD [one match=(_np _nps)]
	_xWILD [s one lookahead match=(
		_prep _vg _np _nps _qEOS \( \, \: \- \" _conj _advl _adv
		_dbldash  \) _fnword )]
	@@

@POST
  S("pp") = 1;
  G("tmp") = N(3);
  group(3,3,"_np");
  pncopyvars(G("tmp"),N(3));
  single();
@RULES
_advl <-
	_prep
	_xWILD [s star match=(_adv _advl)]
	_noun
	@@

@POST
  S("pp") = 1;
  single();
@RULES
_advl <-
	\(
	_prep [s]
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one match=(_np _nps)]
	\)
	@@

_advl <-
	\( [s]
	_xWILD [s one match=(_np _nps)]
	\) [s]
	@@

_advl <-
	as [s]
	_xWILD [s one match=(_adv _advl _seg)]
	as [s]
	_xWILD [s one match=(_adj _adjs _seg)]
	@@

# Some crazy adverbials.
@POST
  S("pp") = 1;
  single();
@RULES
_advl <-
	_dbldash
	_prep [s]
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one match=(_adj _adjs _np _nps)]
	_dbldash
	@@

@RULES
_advl <-
	_dbldash
	_xWILD
	_dbldash
	@@

@POST
  group(2,2,"_np");
@RULES
_xNIL <-
	for [s]
	_xWILD [s one match=(this that these those them)
		except=(_np)]
	to [s lookahead]
	@@

@CHECK
  if (!N("noun",4) && (N("seg type",4) != "np"))
    fail();
  if (N("seg len",4) > 4 && N("seg verbs",4))
    fail();
@POST
  pnrename(N(4),"_np");
@RULES
_xNIL <-
	_xSTART
	_xWILD [s star match=(_adv _advl)]
	\, [s opt]
	_seg
	_xWILD [s star match=(_adv _advl)]
	@@


# Can have a silent "to be" verb to the right, if starting
# a clause.
@POST
  S("pp") = 1;
  single();
@RULES
_advl <-
	_prep
	_xWILD [s one match=(_proObj)]
	@@

@CHECK
  if (pnname(N(2)) == "_np")
     fail();	# Infinite loop guard.
@POST
  singler(2,2);
@RULES
_np [base] <-
	_xSTART
	_xWILD [s one match=(_xNUM _num _quan)]
	_xWILD [s one lookahead match=(_adv _advl)]
	@@

# Some late conjoining.
@POST
  listadd(6,1,"true");
@RULES
_xNIL <-
	_np [s]
	\, [s opt]
	_xWILD [s star match=(_adv _advl)]
	\, [s opt]
	_conj [s]
	_nps [s]
	\, [s opt]
	@@

# ... this month
# this date
@CHECK
  if (N("sem",3) != "date")
    fail();
@POST
  group(3,3,"_advl");
@RULES
_xNIL <-
	_np
	_xWILD [s star match=(_adv _advl)]
	_np
	_xWILD [s one lookahead match=(_qEOS)]
	@@

# vg prep seg and seg
@POST
  if (N("unknown",4) || N("seg type",4) == "np"
   || N("noun",4) )
     {
     pnrename(N(4),"_np");
	 pnrename(N(6),"_np");
	 group(4,6,"_nps");
	 }
  noop();	# Guard against infinite loop.
@RULES
_xNIL <-
	_vg
	_xWILD [s star match=(_adv _advl)]
	as [s]
	_seg
	_conj
	_seg
	@@

@POST
  if (N("unknown",4) || N("seg type",4) == "np"
   || N("noun",4) )
     pnrename(N(4),"_np");
  noop();	# Guard against infinite loop.
@RULES
_xNIL <-
	_vg
	_xWILD [s star match=(_adv _advl)]
	as [s]
	_seg
	@@

# A bit of apposition.
@CHECK
  if (!N("pp",1))
  	fail();
@POST
  group(2,5,"_advl");
  N("appositive",2) = 1;
@RULES
_xNIL <-
	_advl
	\,
	_xWILD [s one match=(_np _nps)]
	_xWILD [s star match=(_adv _advl)]
	\,
	_xWILD [s one lookahead match=(_vg)]
	@@

@CHECK
  if (!N("noun",3) && !N("unknown",3) && N("seg type",3) != "np")
  	fail();
@POST
  pnrename(N(3),"_np");
  single();
@RULES
_nps <-
	_np
	_conj
	_seg
	_conj
	_np
	@@

@CHECK
  if (!N("noun",2) && !N("unknown",2) && N("seg type",2) != "np")
  	fail();
@POST
  pnrename(N(2),"_np");
@RULES
_xNIL <-
	_fnword [s]
	_seg
	_vg
	@@

# Adverbial phrase
# advl and advl
@POST
  group(2,4,"_advl");
@RULES
_xNIL <-
	_xWILD [one match=(_vg)]
	_xWILD [s one match=(_advl _adv)]
	_conj
	_xWILD [s one match=(_advl _adv)]
	_xWILD [one lookahead match=(_np _nps)]
	@@

# as appropriate
@POST
  group(2,2,"_adj");
  group(1,2,"_advl");
  N("pp",1) = 1;
@RULES
_xNIL <-
	_xWILD [s one match=(as when where if)]
	appropriate [s]
	_xWILD [s one lookahead match=(_xPUNCT)]
	@@


@POST
  pncopyvars(2);
  singler(2,3);
@RULES
_np <-
	_xWILD [s one match=( _xPUNCT)]
	_np
	_advl
	_xWILD [s one lookahead match=(_vg _xPUNCT)]
	@@


# such as np
#@RULES
#_advl <-
#	\, [s opt]
#	_fnword [s]
#	_xWILD [s one match=(_np _nps)]
#	\, [s opt]
#	@@
#
