###############################################
# FILE: seg30.pat
# SUBJ: Look within each segment, characterize boundaries.
# AUTH: AM
# CREATED: 17/Mar/02 00:13:05
# MODIFIED:
###############################################

@CODE
G("hello") = 0;
@@CODE

@PATH _ROOT _TEXTZONE _par _seg

# Dissolve first verb.
@CHECK
if (!X("seg split 1st verb"))
	fail();
@POST
  group(3,3,"_np");
  group(2,2,"_vg");
  X("dissolve") = 1;
  X("id") = "seg30 001";
@RULES
_xNIL <-
  _xSTART
  _xANY
  _xANY [plus]
  _xEND
  @@

# noun alpha adj
# Todo: look for copula.
@CHECK
  if (!N("verb",4))
    fail();
@POST
  group(4,4,"_verb");
  group(4,4,"_vg");
  group(2,3,"_np");
  X("dissolve") = 1;
  X("id") = "seg30 002";
@RULES
_xNIL <-
	_xSTART
	_xANY [star]
	_noun [trigger]
	_xALPHA
	_adj
	_xEND
	@@

# Need more evidence before deciding to dissolve. # 09/05/02 AM.
# noun alpha
@CHECK
  if (number(N(3)) == "plural"
   || N("adv",4) )
    succeed();
  if (!N("verb",4))
    fail();
  if (X("nodissolve") && N("noun",4))
    fail();
  if (X("right verb"))	# 09/05/02 AM.
    fail();
  S("vconj") = vconj(N(4));
  if (S("vconj") == "-ing")
    fail();	# Too little evidence.	# 09/05/02 AM.
@POST
  X("dissolve") = 1;
  S("tmp") = N(4);
  S("node") = N(3);
  group(4,4,"_seg");
  N("id",4) = "seg30 003";
  pncopyvars(S("tmp"),N(4));
  N("seg type",4) = "alpha";
  N("seg len",4) = 1;
  if (N("noun",4))
    N("seg nouns",4) = 1;
  if (N("adj",4))
    N("seg adjs",4) = 1;
  if (N("verb",4))
    N("seg verbs",4) = 1;
  if (N("adv",4))
    N("seg advs",4) = 1;
  group(2,3,"_np");
  pncopyvars(S("node"),N(2));
  N("id",2) = "seg30 003";
@RULES
_xNIL <-
	_xSTART
	_xANY [star]
	_noun [trigger]
	_xALPHA
	_xEND
	@@

# noun adj
@POST
  X("dissolve") = 1;
  group(2,3,"_np");
  X("id") = "seg30 004";
@RULES
_xNIL <-
	_xSTART
	_xANY [star]
	_noun [trigger]
	_adj
	_xEND
	@@


# X seemed pleased

@CHECK
 # Really want to check for a copula type verb.
 # (appeared, seemed, etc.
  S("stem") = N("stem",3);
  if (!S("stem"))
 	fail();
  if (S("stem") == "appear"
   || S("stem") == "seem"
   || S("stem") == "remain"
   || S("stem") == "become"
   )
   succeed();
  fail();
@POST
  X("dissolve") = 1;
  if (N("unknown",2))
    group(2,2,"_np");
  group(3,3,"_vg");
  if (N("adj",4))
    group(4,4,"_adj");
  X("id") = "seg30 005";
@RULES
_xNIL <-
	_xSTART
	_xANY
	_verb [trigger]
	_xANY
	_xEND
	@@

@POST
  X("dissolve") = 1;
  group(3,3,"_vg");
  group(2,2,"_np");
  X("id") = "seg30 006";
@RULES
_xNIL <-
	_xSTART
	_noun
	_verb
	_xEND
	@@

@CHECK
  if (!N("verb",3))
  	fail();
  if (N("pos num",3) == 1)
  	succeed();
  if (!N("noun",3))
  	succeed();
#  if (N("inf"))
#  	succeed();
#  S("text") = strtolower(N("$text",3));
#  if (suffix(S("text"),"s"))
#    succeed();
  fail();
  
  # Need some agreement checks with noun.
@POST
  X("dissolve") = 1;
  group(3,3,"_verb");
  group(3,3,"_vg");
  group(2,2,"_np");
  X("id") = "seg30 007";
@RULES
_xNIL <-
	_xSTART
	_noun
	_xALPHA
	_xEND
	@@

# Looking for verb glommed at end of np.
@CHECK
  if (N("pos num",3) == 1 && N("verb",3))
  	succeed();
  S("text") = strtolower(N("$text",3));
  if (!strendswith(S("text"),"ed")
   && !N("-edn",3) )
  	fail();
@POST
  X("dissolve") = 1;
  group(3,3,"_vg");
  group(2,2,"_np");
  X("id") = "seg30 008";
@RULES
_xNIL <-
	_xSTART
	_xWILD [plus]
	_verb
	_xEND
	@@

@CHECK
  if (!N("noun",3))
    fail();
  if (!N("verb",4))
    fail();
  if (N("noun",4) || N("noun",5))
    fail();
@POST
  X("dissolve") = 1;
  if (N("adj",5))
    {
	S("tmp") = N(5);
    group(5,5,"_adj");
	pncopyvars(S("tmp"),N(5));
	}
  S("tmp") = N(4);
  group(4,4,"_verb");
  group(4,4,"_vg");
  pncopyvars(S("tmp"),N(4));
  S("tmp") = N(3);
  group(3,3,"_noun");
  group(2,3,"_np");
  pncopyvars(S("tmp"),N(2));
  X("id") = "seg30 008.5";
@RULES
_xNIL <-
	_xSTART
	_xANY [star]
	_xALPHA [trigger]
	_xALPHA
	_xALPHA
	_xEND
	@@

@CHECK
  if (!N("noun",5)
   || !N("verb",4)
   || !N("noun",3) )
   fail();
  if (N("noun",4) || N("adj",4))
  	fail();
  S("text") = strtolower(N("$text",4));
  if (!strendswith(S("text"),"ed")
   && !strendswith(S("text"),"ing")
   && !suffix(S("text"),"s") )
   fail();
@POST
  X("dissolve") = 1;
  group(5,5,"_np");
  group(4,4,"_verb");
  group(4,4,"_vg");
  group(2,3,"_np");
  X("id") = "seg30 009";
@RULES
_xNIL <-
	_xSTART
	_xANY [plus]
	_xANY
	_xALPHA [trigger]
	_xALPHA
	_xEND
	@@

@CHECK
  if (N("pos num",3) == 1 && N("verb",3))
  	succeed();
  if (N("inf",3))
  	fail();
  S("text") = strtolower(N("$text",3));
  if (!strendswith(S("text"),"ed")
   && !N("-edn",3) )
  	fail();
@POST
  X("dissolve") = 1;
  group(3,3,"_verb");
  group(3,3,"_vg");
  group(2,2,"_np");
  X("id") = "seg30 010";
@RULES
_xNIL <-
	_xSTART
	_xANY [plus]
	_xALPHA [trigger]
	_xEND
	@@

@POST
  X("seg type") = "np";
  if (N(5))
    S("last") = lasteltnode(5);
  else if (N(4))
    S("last") = lasteltnode(4);
  else if (N(3))
    S("last") = lasteltnode(3);
  else
    "error.txt"
		<< "[Warning: "
		<< X("id") << ".  Lone det in seg.]"
		<< "\n";
  if (S("last"))
    {
	# Ignoring noun-noun phrases etc, for now.
	X("last node") = S("last");
	pncopyvars(S("last"),X());
	X("np stem") = pnvar(S("last"),"stem");
	}
  X("id") = "seg30 011";
@RULES
_xNIL <-
	_xSTART
	_xWILD [s one match=(_det _proPoss)]
	_xWILD [s opt match=(_xNUM _quan _num)]
	_xWILD [s star match=(_adjs _adj)]
	_noun [s star]
	_xEND
	@@

# 07/18/02 AM.
_xNIL <-
	_xSTART
	_xWILD [s one match=(_det _proPoss)]
	_xWILD [s opt match=(_xNUM _quan _num)]
	_xWILD [s star match=(_adjs _adj _xALPHA)
		except=(_noun)]
	_noun [s plus]
	_xEND
	@@
_xNIL <-	# 07/24/02 AM.
	_xSTART
	_xWILD [s one match=(_det _proPoss)]
	_xWILD [s opt match=(_xNUM _quan _num)]
	_xWILD [s star match=(_adjs _adj)]
	_xALPHA
	_xEND
	@@
_xNIL <-	# 07/24/02 AM.
	_xSTART
	_xWILD [s one match=(_det _proPoss)]
	_xWILD [s opt match=(_xNUM _quan _num)]
	_xALPHA
	_xALPHA
	_xEND
	@@

# det alpha alpha alpha
# a book found decaying
@POST
  S("conj2") = vconj(N(5));
  S("conj1") = vconj(N(4));
  if (S("conj2") == "-ing"
   && (S("conj1") == "-edn" || S("conj1") == "-en") )
    {
	S("tmp") = N(5);
	group(4,5,"_vg");
	pncopyvars(S("tmp"),N(4));
	S("tmp") = lasteltnode(3);
	group(2,3,"_np");
	pncopyvars(S("tmp"),N(2));
	X("dissolve") = 1;
	}
  X("id") = "seg30 011.5";
@RULES
_xNIL <-
	_xSTART
	_xWILD [s one match=(_det _proPoss)]
	_xWILD
	_xALPHA
	_xALPHA [trigger]
	_xEND
	@@

@POST
  X("seg type") = "np";
  X("id") = "seg30 012";
@RULES
_xNIL <-
	_xSTART
	_xWILD [s star match=(_adv _advl)]
	_xWILD [s one match=(_xNUM _quan _num)]
	_xWILD [s star match=(_adjs _adj)]
	_noun [s star]
	_xEND
	@@
@POST
  X("seg type") = "np";
  X("id") = "seg30 013";
@RULES
_xNIL <-
	_xSTART
	_xWILD [s plus match=(_adjs _adj)]
	_noun [s star]
	_xEND
	@@

@CHECK
  if (X("seg type") != "np")
    fail();
@POST
  # May want to group _np, _vg, and flag "dissolve" segment.
  "dump.txt" << "np seg with verb end=" << phrasetext() << "\n";
  X("id") = "seg30 014";
  noop();
@RULES
_xNIL <-
	_xSTART
    _xWILD
	_xWILD [one match=(_verb)]
	_xEND
	@@

#@POST
#  # May want to group _np, _vg, and flag "dissolve" segment.
#  "dump.txt" << "np seg with alpha end=" << phrasetext() << "\n";
#  noop();
#@RULES
#_xNIL <-
#	_xSTART
#	_xWILD
#	_noun [plus]
#	_xALPHA
#	_xEND
#	@@

@CHECK
  if (!N("noun",3))
    fail();
  if (N("verb",3))
    {
	S("text") = strtolower(N("$text",3));
	if (strendswith(S("text"),"ed")
	 || N("-edn",3) )
		fail();
	}
@POST
  X("seg type") = "np";
  X("id") = "seg30 015";
@RULES
_xNIL <-
	_xSTART
	_xWILD [plus match=(_adj _adjs)]
	_xALPHA
	_xEND
	@@

# Well formed noun.
@CHECK
  if (!N("adj",2) && !N("noun",2))
  	fail();
  if (N("verb",2))
  	fail();
  if (N(3))
    {
    if (!N("adj",3) && !N("noun",3))
      fail();
    if (N("verb",3))
      fail();
	}
@POST
  xrename("_np");	# Rename _seg to _np.
  X("id") = "seg30 016";
@RULES
_xNIL <-
	_xSTART
	_xALPHA
	_xALPHA [opt]
	_noun
	_xEND
	@@

#@POST
#	S("text") = strtolower(N("$text",2));
#	if (N("verb",2) && (strendswith(S("text"),"ed")
#	 || strendswith(S("text"),"ing")
#	 || N("-edn",2) ))
#	  xrename("_vg");
#  X("id") = "seg30 017";
#@RULES
#_xNIL <-
#	_xSTART
#	_xALPHA
#	_xEND
#	@@

@POST
  xrename("_np");
  X("id") = "seg30 018";
@RULES
_xNIL <-
	_xSTART
	_noun
	_xEND
	@@

@POST
 X("dissolve") = 1;
 group(3,5,"_np");
 group(2,2,"_vg");
  X("id") = "seg30 019";
@RULES
_xNIL <-
  _xSTART
  _verb
  _xWILD
  _noun
  _xALPHA [opt]
  _xEND
  @@

@POST
  S("vconj") = vconj(N(2));
  if (X("nosplit left")	# A verb immediately to the left.
   || !N("verb",2)
   || (S("vconj") != "-ed") )
    {
	xrename("_np");
	pncopyvars(N(4),X());
	}
  else
    {
    X("dissolve") = 1;
	S("tmp") = N(4);
    group(3,5,"_np");
	pncopyvars(S("tmp"),N(3));
    group(2,2,"_vg");
    }
  X("id") = "seg30 020";
@RULES
_xNIL <-
  _xSTART
  _xALPHA
  _xWILD
  _noun
  _xALPHA [opt]
  _xEND
  @@

@CHECK
  if (!N("noun",3) && !N("unknown",3) && !N("adj",3))
     fail();
@POST
  X("dissolve") = 1;
  group(4,5,"_np");
  group(2,3,"_np");
  X("id") = "seg30 021";
@RULES
_xNIL <-
	_xSTART
	_xANY [star]
	_xALPHA
	_num [trigger]
	_xANY [star]
	_xEND
	@@
	

# unknown num
# noun num.
@POST
  xrename("_np");
  X("id") = "seg30 022";
@RULES
_xNIL <-
	_xSTART
	_xALPHA
	_xNUM
	_xEND
	@@

# noun first verb
@POST
  if (N("verb",5))
    {
	X("dissolve") = 1;
	if (pnname(N(5)) != "_verb")
	  group(5,5,"_verb");
	group(4,4,"_adv");
	group(4,5,"_vg");
	group(2,3,"_np");
	}
  X("id") = "seg30 023";
@RULES
_xNIL <-
	_xSTART
	_xANY [star]
	_noun
	first [s trigger]
	_xANY
	_xEND
	@@

# det adj alpha
@CHECK
  if (!N("noun",4))
    fail();
@POST
  xrename("_np");
  if (N("stem",4))
    X("np stem") = N("stem",4);
  else
    X("np stem") = N("$text",4);
  X("id") = "seg30 024";
@RULES
_xNIL <-
	_xSTART
	_det
	_adj
	_xALPHA
	_xEND
	@@

@CHECK
  if (!X("seg nouns"))
    fail();
@POST
  X("dissolve") = 1;
  S("head") = lasteltnode(2);
  S("adj") = lasteltnode(4);
  group(3,4,"_adj");
  pncopyvars(S("adj"),N(3));
  group(2,2,"_np");
  pncopyvars(S("head"),N(2));
@RULES
_xNIL <-
	_xSTART
	_xANY [plus]
	_xWILD [s one trigger match=(just)]
	_xANY [plus]
	_xEND
	@@

######### NUM #########
@POST
  X("seg type") = "np";
  if (N(4))
    S("last") = lasteltnode(4);
  else if (N(3))
    S("last") = lasteltnode(3);
  else
    "error.txt"
		<< "[Warning: "
		<< X("id") << ".  Lone det in seg.]"
		<< "\n";
  if (S("last"))
    {
	# Ignoring noun-noun phrases etc, for now.
	X("last node") = S("last");
	pncopyvars(S("last"),X());
	X("np stem") = pnvar(S("last"),"stem");
	}
  X("id") = "seg30 025";
@RULES
_xNIL <-
	_xSTART
	_xWILD [s one match=(_xNUM _quan _num)]
	_xWILD [s star match=(_adjs _adj)]
	_noun [s star]
	_xEND
	@@

_xNIL <-
	_xSTART
	_xWILD [s one match=(_xNUM _quan _num)]
	_xWILD [s star match=(_adjs _adj _xALPHA)
		except=(_noun)]
	_noun [s plus]
	_xEND
	@@
_xNIL <-
	_xSTART
	_xWILD [s one match=(_xNUM _quan _num)]
	_xWILD [s star match=(_adjs _adj)]
	_xALPHA
	_xEND
	@@
_xNIL <-
	_xSTART
	_xWILD [s one match=(_xNUM _quan _num)]
	_xALPHA
	_xALPHA
	_xEND
	@@

