###############################################
# FILE: seg400.pat
# SUBJ: Find verbs in a segment.
# AUTH: AM
# CREATED: 16/May/02 14:15:01
# MODIFIED:
###############################################

@CODE
G("hello") = 0;
@@CODE

@PATH _ROOT _TEXTZONE _par _sentence _seg

# Dissolve first verb.
@CHECK
if (!X("seg split 1st verb"))
	fail();
@POST
  group(3,3,"_np");
  group(2,2,"_vg");
  X("dissolve") = 1;
@RULES
_xNIL <-
  _xSTART
  _xANY
  _xANY [plus]
  _xEND
  @@

# Dissolve last verb.
@CHECK
if (!X("seg split last verb"))
  fail();
@POST
  group(3,3,"_vg");
  group(2,2,"_np");
  X("dissolve") = 1;
@RULES
_xNIL <-
  _xSTART
  _xANY [plus]
  _xWILD [one trigger match=(_xALPHA _verb)]
  _xEND
  @@

# Simplistic heuristic.  1st verb found in a segment is chosen.
@CHECK
  if (!N("verb"))
    fail();
  if (X("found verb"))
    fail();
  if (vconj(N(1)) == "inf")
    fail();
  if (X("seg len") > 4)
    succeed();
  if (!X("vgs",4))
    succeed();
  fail();
@POST
  S("tmp") = N(1);
  group(1,1,"_verb");
  group(1,1,"_vg");
  pncopyvars(S("tmp"),N(1));
  X("found verb") = 1;  # This also flags dissolve of segment.
@RULES
_xNIL <-
	_xALPHA
	@@
