###############################################
# FILE: seg50.pat
# SUBJ: Assign segments.
# AUTH: AM
# CREATED: 27/Feb/02 11:12:56
# ASSUME:	Assumes segments have been characterized,
#	boundaries fixed, etc. (more or less).
###############################################

@CODE
G("hello") = 0;
@@CODE

@PATH _ROOT _TEXTZONE _par

# at location
@CHECK
  if (N("seg type") != "alpha")
    fail();
  if (N("dissolve",2))
  	fail();
@POST
  pnrename(N(2), "_np");
  N("id",2) = "seg50 01";
@RULES
_xNIL <-
	_xWILD [s one match=(at in)]
	_seg
	@@

# DISSOLVE SOME SEGMENTS.
@CHECK
  if (!N("dissolve"))
  	fail();
@POST
  splice(1,1);
@RULES
_xNIL <-
	_seg
	@@

# Sentinel.
# Ignore big segs that may need splitting.
@CHECK
  if (N("seg len") < 5)
    fail();
  if (!N("seg verbs"))
    fail();
@POST
  noop();
@RULES
_xNIL <- _seg @@

@CHECK
  if (N("seg type") == "np" && N("seg last verb")
    && N("seg nouns") > 1)
  	fail();
@POST
  if (N("seg type") != "alpha") # Any characterized seg.
    pnrename(N(1), "_" + N("seg type"));
  else if (N("pos num") == 1)
    {
    if (N("adj"))
  	  pnrename(N(1), "_adj");
    else if (N("noun"))
	  pnrename(N(1), "_np");
	else if (N("verb"))
	  pnrename(N(1),"_vg");
	else if (N("adv"))
	  pnrename(N(1),"_adv");
	}
  else if (N("num") || N("val"))
  	pnrename(N(1),"_np");
  N("id",1) = "seg50 02";
@RULES
_xNIL <-
	_seg
	@@

@CHECK
  if (!N("noun",2))
  	fail();
  if (N("dissolve",2))
  	fail();
@POST
  pnrename(N(2), "_np");
  N("id",2) = "seg50 03";
@RULES
_xNIL <-
	_prep [s]
	_seg
	_prep [s lookahead]
	@@

@POST
  pncopyvars(1);
  singler(1,1);
@RULES
_np <-
	_noun
	_xWILD [s one lookahead fail=( \" )]
	@@

@POST
  group(2,2,"_np");
@RULES
_xNIL <-
	_prep [s]
	_det [s]
	_xWILD [s one lookahead match=(_qEOS)]
	@@

@POST
  group(2,2,"_np");
@RULES
_xNIL <-
	_prep [s]
	_xWILD [one match=(_xNUM _num _quan)]
	_xWILD [s one lookahead match=(_prep)]
	@@
