###############################################
# FILE: seg_glom50.pat
# SUBJ: Glom segments together.
# AUTH: AM
# CREATED: 24/Apr/02 20:07:03
# MODIFIED:
###############################################

@CODE
G("hello") = 0;
@@CODE

@PATH _ROOT _TEXTZONE _par _sentence

# Some sentence characterization....
# neither ... nor evidence.
@CHECK
  if (N("counted"))
    fail();
@POST
  ++X("nor");  # Sentence has "nor" in it.
  N("counted") = 1;
@RULES
_xNIL <- nor [s] @@

# 05/01/02 AM. Throwing this in the mix.
@POST
  S("sem1") = nodesem(N(1));
  if (S("sem1") == "sign"	# Or other idiomatic...
   || N("dom slot",3) )
    pncopyvars(3);
  else
    pncopyvars(1);
  domcompose(N(1),N(3));
  if (N("eventive",1))
  	{
	S("eventive") = 1;
	S("dom val") = N("$text",1);	# 09/22/02 AM.
	if (N("nps",3))
	  S("nps") = N("nps",3);
	else
	  S("nps") = N(3);
    S("pattern") = "np-of-np";	# Verbless, eventive np...
	}
  if (N("neg",1) || N("neg",3))
    S("neg") = 1;
  singler(1,3);
@RULES
_np <-
	_xWILD [one match=(_np _nps)]
	of [s]
	_xWILD [one match=(_np _nps)]
	_xWILD [s one lookahead fail=(_conj)]
	@@

@POST
  pnrename(N(2),"_np");
  N("id",2) = "segglom50 01";
  singler(2,7);
@RULES
_nps <-
	_xWILD [s one match=(_prep)]
	_seg
	\, [s]
	_np [s]
	\, [s opt]
	_conj [s]
	_np [s]
	@@

@POST
  pnrename(N(3),"_np");
  N("id",3) = "segglom50 02";
  singler(1,6);
@RULES
_nps <-
	_np
	\, [s]
	_seg [s]
	\, [s opt]
	_conj [s]
	_np [s]
	@@

@POST
  group(4,4,"_np");
  group(2,2,"_np");
  singler(2,7);
@RULES
_nps <-
	_xWILD [s one match=( \( )]
	_noun
	\, [s]
	_noun
	\, [s opt]
	_conj [s]
	_np [s]
	@@

@CHECK
  if (!N("seg nouns",3))
    fail();
@POST
  pnrename(N(3),"_np");
  N("id",3) = "segglom50 03";
  singler(1,3);
@RULES
_nps <-
	_np
	\, [s]
	_seg
	\, [s lookahead]
	_xWILD [s one match=(_seg _conj)]
	@@

@CHECK
  if (!N("seg nouns",3))
    fail();
@POST
  pnrename(N(3),"_np");
  N("id",3) = "segglom50 04";
  listadd(1,3,"false");
@RULES
_xNIL <-
	_nps
	\, [s]
	_seg
	\, [s lookahead]
	_xWILD [s one match=(_seg _conj)]
	@@

@CHECK
  if (!N("seg nouns",4))
    fail();
@POST
  pnrename(N(4),"_np");
  N("id",4) = "segglom50 05";
  listadd(1,4,"false");
@RULES
_xNIL <-
	_nps
	\, [s opt]
	_conj
	_seg
	@@

# Some simplification
# "will need to be moved"
@POST
  pncopyvars(5);
  S("first verb") = N(1);
  S("last verb") = N(5);
  S("act stem") = N("stem",5);
  S("act sem") = N("sem",5);
  if (N(6))
    S("act particle") = N(6);	# 09/05/02 AM.
  single();
@RULES
_vg <-
	_vg
	_xWILD [s star match=(_adv _advl)]
	to [s]
	_xWILD [s star match=(_adv _advl)]
	_vg
	_prep [opt]	# Particle.	# 09/05/02 AM.
	@@

# blue and green car.
# should qualify np as not starting with det, etc.
@POST
  listadd(3,1, "false");
@RULES
_xNIL <-
	_adj
	_conj [s]
	_np
	_xWILD [s one lookahead match=(_qEOS \, )]
	@@


# these cranky, and therefore dangerous, blippers.
@POST
  listadd(8,1, "true");
@RULES
_xNIL <-
	_det [s]
	_xWILD [s one match=(_seg _adj _adjs)]
	\, [s opt]
	_conj [s]
	_xWILD [s star match=(_adv _advl)]
	_adj [s]
	\, [s opt]
	_np
	@@

@CHECK
  if (N("sem",1) == "date"
   && N("sem",3) != "date")
    fail();
@POST
  listadd(3,1,"false");
@RULES
_xNIL <-
	_np
	\, [s]
	_nps
	@@

@CHECK
	if (!N("noun",1) && (N("seg type",1) != "np")
	 && !N("unknown",1) )
	  fail();
@POST
  pnrename(N(1), "_np");
  N("id",1) = "segglom50 06";
  listadd(3,1,"false");
@RULES
_xNIL <-
	_seg
	\, [s]
	_nps
	@@

@RULES
_nps <-
	_xSTART
	_np
	_xWILD [s star match=(_adv _advl)]
	_conj [s]
	_xWILD [s star match=(_adv _advl)]
	_np
	@@

#np conj np
@CHECK
  if (N("eventive",5) && !N("eventive",1))
    fail();
@POST
  if (N("dom slot",1))
    S("dom slot") = N("dom slot",1);
  else if (N("dom slot",5))
    S("dom slot") = N("dom slot",5);
  S("sems")[0] = nodesem(N(1));
  S("sems")[1] = nodesem(N(5));
  S("pn nps")[0] = N(1);
  S("pn nps")[1] = N(5);
  domcompose(N(1),N(5));
  singler(1,5);
@RULES
_nps <-
	_np
	_xWILD [s star match=(_adv _advl)]
	_conj [s]
	_xWILD [s star match=(_adv _advl)]
	_np
	_xWILD [s one lookahead match=(_qEOS _xEND)]
	@@

#_nps <-
#	_xWILD [s one match=(_prep _vg _fnword)]
#	_np
#	_xWILD [s star match=(_adv _advl)]
#	_conj [s]
#	_np
#	_xWILD [s one lookahead match=(_vg _adv _advl _qEOS _conj \,)]
#	@@

@POST
  listadd(2,4,"true");
@RULES
_xNIL <-
	_xWILD [s one match=(_prep)]
	_nps
	_conj [s]
	_np
	_xWILD [s one lookahead match=(_vg _adv _advl _qEOS \, )]
	@@

@CHECK
  if (!N("noun",3) && (N("seg type",3) != "np"))
  	fail();
@POST
  pnrename(N(3),"_np");
  N("id",3) = "segglom50 07";
  listadd(1,3,"true");
@RULES
_xNIL <-
	_nps
	_conj
	_seg
	_xWILD [s one lookahead match=(_vg _adv _advl _qEOS _prep)]
	@@

@CHECK
  if (!N("noun",3) && (N("seg type",3) != "np")
    && !N("unknown",3) )
  	fail();
@POST
  if (N("stem",1) && N("stem",3))
    {
    S("stems")[0] = N("stem",1);
	S("stems")[1] = N("stem",3);
	}
  else if (N("stem",1))
    S("stems")[0] = N("stem",1);
  else if (N("stem",3))
    S("stems")[0] = N("stem",3);
  
  if (N("sem",1) && N("sem",3))
    {
    S("sems")[0] = N("sem",1);
	S("sems")[1] = N("sem",3);
	}
  else if (N("sem",1))
    S("sems")[0] = N("sem",1);
  else if (N("sem",3))
    S("sems")[0] = N("sem",3);
  if (N("eventive",1) || N("eventive",3))
    S("eventive") = 1;
  pnrename(N(3),"_np");
  N("id",3) = "segglom50 08";
  singler(1,3);
@RULES
_nps <-
	_np
	_conj
	_seg
	_xWILD [s one lookahead match=(_vg _adv _advl _qEOS \, _prep)]
	@@

# after blanking and cessation.
@CHECK
  if (!N("noun",2) && (N("seg type",2) != "np"))
	fail();
@POST
  pnrename(N(2),"_np");
  N("id",2) = "segglom50 09";
  singler(2,4);
@RULES
_nps <-
	_xWILD [s one match=(_prep _adv _advl) except=(to)]
	_seg
	_conj
	_np
	_xWILD [one lookahead fail=(_verb _vg)]
	@@

@CHECK
  if (N("noun",2))
    succeed();
  if (N("seg type",2) == "np")
    succeed();
@POST
  pnrename(N(2),"_np");
  N("id",2) = "segglom50 10";
  singler(2,4);
@RULES
_nps <-
	_xSTART
	_seg
	_conj
	_np
	@@

#@RULES
#_nps <-
#	_np
#	_conj
#	_np
#	@@


# Adverbial starts of sentence.
# Eg, "Now I ...."
@CHECK
  if (N("seg len",2) > 1)
    fail();
  if (!N("adv",2))
  	fail();
@POST
  pnrename(N(2),"_adv");
  N("id",2) = "segglom50 11";
@RULES
_xNIL <-
	_xSTART
	_seg
	_xWILD [one lookahead fail=(_vg _verb)]
	@@

@CHECK
	if (!N("noun",2))
		fail();
	if (N("seg len",2) == 1)
	  fail();
@POST
  pnrename(N(2),"_np");
  N("id",2) = "segglom50 12";
@RULES
_xNIL <-
	_vg
	_seg
	@@

# into heavy, gross eating.
@CHECK
  if (!N("adj",2) && !N("noun",2))
  	fail();
  if (!N("noun",5) && (N("seg type",5) != "np"))
  	fail();
@POST
  pnrename(N(2),"_adj");
  N("id",2) = "segglom50 13";
  pnrename(N(5),"_np");
  N("id",5) = "segglom50 13";
  listadd(5,2,"false");
@RULES
_xNIL <-
	_prep
	_seg
	\,
	_xWILD [s star match=(_adv _advl)]
	_seg
	_xWILD [one lookahead match=(_qEOS)]
	@@

# Disambiguation of this and that ;-)
@POST
  listadd(2,1,"false");
@RULES
_xNIL <-
	_xWILD [s one match=(this that these those)]
	_np
	_xWILD [one lookahead match=(_qEOS)]
	@@

@CHECK
  if (N("seg type",3) == "vg")
  	succeed();
  if (N("verb",3))
    succeed();
  # Want to check verb agreement here.
  fail();
@POST
  pnrename(N(3),"_vg");
  N("id",3) = "segglom50 14";
  single();
@RULES
_vg <-
	_vg
	_conj
	_seg
	@@

@POST
  # If needed...
  if (pnname(N(2)) == "_seg")
    {
    pnrename(N(2),"_np");
    N("id",2) = "segglom50 15";
	}
  if (pnname(N(4)) == "_seg")
    {
    pnrename(N(4),"_np");
    N("id",4) = "segglom50 15";
	}
  single();
@RULES
_np <-
	both [s]
	_xWILD [s one match=(_seg _np _nps)]
	_conj [s]
	_xWILD [s one match=(_seg _np _nps)]
	@@

@CHECK
	# To keep from infinite loop.
	if (!N("noun",2))
		fail();
@POST
  if (N("noun",2))
    {
    pnrename(N(2),"_np");
    N("id",2) = "segglom50 16";
	}
@RULES
_xNIL <-
	_xWILD [s one match=(_conj)]
	_seg
	_xWILD [s one lookahead match=(_qEOS)]
	@@

# If seg hasn't participated in anything, assign.
@CHECK
  if (!N("unknown"))
  	fail();
@POST
#  pnrename(N(1),"_noun");
  pnrename(N(1),"_np");
  N("id",1) = "segglom50 17";
@RULES
_xNIL <-
	_seg
	@@

@POST
  S("paren np") = 1;
  single();
@RULES
_advl <-
	\( [s]
	_xWILD [s one match=(_np _nps)]
	\) [s]
	@@

@CHECK
  if (!N("paren np",2))
  	fail();
  if (!N("noun",1) && (N("seg type",1) != "np"))
    fail();
@POST
  pnrename(N(1),"_np");
  N("id",1) = "segglom50 18";
  single();
@RULES
_np <-
	_seg
	_advl
	_np
	@@

@CHECK
  if (!N("adj",3))
  	fail();
@POST
  pnrename(N(3),"_adj");
  N("id",3) = "segglom50 19";
  single();
@RULES
_adj <-
	_adj
	_conj
	_seg
	@@

# of even a blank.
@CHECK
  if (!N("adv",2))
  	fail();
@POST
  pnrename(N(2),"_adv");
  N("id",2) = "segglom50 20";
@RULES
_xNIL <-
	_xWILD [s one match=(_prep)]
	_seg
	_np [s lookahead]
	@@

# parens in np
@CHECK
  if (!N("paren np",2))
    fail();
@POST
  listadd(1,2,"false");
@RULES
_xNIL <-
	_xWILD [s one match=(_nps _np)]
	_advl
	@@

# np seg
@CHECK
  if (N("verb",2))
    fail();
  if (!N("noun",2) && !N("adj",2))
    fail();
@POST
  if (N("noun",2))
    {
    pnrename(N(2),"_np");
    N("id",2) = "segglom50 21";
	listadd(1,2,"false");
	}
  else if (N("adj",2))
    {
    pnrename(N(2),"_adj");
    N("id",2) = "segglom50 21";
	}
@RULES
_xNIL <-
	_xWILD [s one match=(_np _nps)]
	_seg
	_xWILD [s one lookahead match=(_qEOS _prep _xPUNCT _fnword
		_conj)]
	@@

@POST
 N("quoted",2) = 1;
 excise(3,3);
 excise(1,1);
@RULES
_xNIL <-
	\" [s]
	_xANY
	\" [s]
	@@

# Business stuff.
# np , company stock
@POST
  S("sem") = "company";
  single();
@RULES
_np <-
	_xWILD [s one match=(_np _nps)]
	\, [s opt]
	_companyABBR [s]
	_stockSYMBOL [s opt]
	@@
_np <-
	_xWILD [s one match=(_np _nps)]
	_stockSYMBOL [s]
	@@
