###############################################
# FILE: zone4.pat
# SUBJ: Examine zones for merging
# AUTH: AM
# CREATED: 21/Mar/02 19:08:23
# NOTE:	Now that zones are elaborated (prose vs nonprose),
#	want to look at singletons that are wedged between large
#	zones.  May try to unify "rough zones" that alternate
#	1 2 1 1 2 1 etc.
#	Ultimately, merging must be based on line-oriented content
#	analysis -- which brings to mind a nice method for incremental
#	text analysis.
###############################################

@CODE
if (!G("zoning"))
	exitpass();
@@CODE

@NODES _ROOT

# Sentinel.
# Don't merge a very short start zone.  Could be a header.
@CHECK
  if (N("line count",2) <= 2)
    fail();
@POST
  noop();
@RULES
_xNIL <-
	_xSTART
	_zone
	@@

# Heur: Looking for a short zone to glom.
# Note: Rule always "fails", but sometimes has side effect.
@CHECK
  if (N("line count",1) > 1
   && N("line count",2) > 1)
     fail();
 if (!N("prose zone",1) || !N("prose zone",2))
 	fail();
 if (N("sloppy end",1)
   || N("end dash",1)
   || N("end comma",1)
   || N("sloppy start",2)
   )
    {
	N("rt",1) = 1;	# Flag: merge to right.
	N("lt",2) = 1;	# Flag: merge to left.
	}
  fail();
@POST
  noop();
@RULES
_xNIL <-
	_zone
	_zone [lookahead]
	@@
