###############################################
# FILE: zone_merge.pat
# SUBJ: Merge zones.
# AUTH: AM
# CREATED: 22/Mar/02 00:02:32
# MODIFIED:
###############################################

@CODE
if (!G("zoning"))
	exitpass();
@@CODE

@NODES _ROOT

# Merge prose zones marked for merging.
# Also merge adjacent prose zones.
@CHECK
  if (N("rt",1)
   && N("lt",2))
    succeed();
  if (N("prose zone",1)
   && N("prose zone",2)
   && N("line count",1) > 2
   && N("line count",2) > 2
   && !N("end punct",1)
   )
    succeed();
  fail();
@POST
  # Promote selected stuff.
  S("prose zone") = 1; # Only merging prose.
  S("line count") = N("line count",1) + N("line count",2);
  
  S("sloppy start") = N("sloppy start",1);
 
  S("end punct") = N("end punct",2);
  S("end dash") = N("end dash",2);
  S("end comma") = N("end comma",2);
  S("sloppy end") = N("sloppy end",2);
  merger(1,2);
@RULES
_zone <-
	_zone
	_zone
	@@
