/*******************************************************************************
Copyright (c) 1998,1999 by Text Analysis International, Inc.
All rights reserved.  No part of this document may be copied, used, or
modified without written permission from Text Analysis International, Inc.
********************************************************************************
*
* NAME:	UCODE.H
* FILE:	c:\dev\nlplite\ucode.h
* CR:		12/08/98 AM.
* SUBJ:	User-defined code actions for the Pat pass.
* NOTE:	This class is a convenience for registering user-defined code
*			actions. The user
*			class has to be registered with NLP Lite.
*
*******************************************************************************/

#ifndef UCODE_H_
#define UCODE_H_
#include <assert.h>
//#include "user.h"				// 01/29/99 AM.
#include "lite/dlist.h"
#include "lite/code.h"


// Forward references
class Parse;
class Auser;																	// 02/13/01 AM.
class Nlppp;																	// 02/14/01 AM.

/********************************************
* CLASS:	USER
* CR:		12/08/98 AM.
* SUBJ:	Convenience class for code actions.
********************************************/

class USER_API user
{
	//friend ostream &operator<<(ostream &, user &);

public:
	user();										// Default constructor.
	~user();

	// Access

	// Modify

	// General.
//	virtual bool execute(			// 01/29/99 AM.
	static bool execute(				// 01/29/99 AM.
		char *func,
		Delt<Iarg> *args,
		Auser *auser);															// 02/13/01 AM.

	// Class-wide
	static bool userTestfn(Delt<Iarg>*,Auser*);
	static bool userAnalyzefile(Delt<Iarg>*,Auser*);
	static bool userAnalyzebuf(Delt<Iarg>*,Auser*);
	static bool userLoadanalyzer(Delt<Iarg>*,Auser*);
	static bool userUnloadanalyzer(Delt<Iarg>*,Auser*);

	// RUNTIME VARIANTS GO HERE.
	static char *testfn(Nlppp *);

	// Run another analyzer on a file.
	// Grab outputs by the analyzer to the cbuf text buffer.
	// Args: analyzer_str, inpfile_str, datum_str, ostream.
	static char *analyzefile(Nlppp*,char*,char*,char*,ostream*);
	static char *analyzefile(Nlppp*,char*,RFASem*,char*,ostream*);
	static char *analyzefile(Nlppp*,RFASem*,char*,char*,ostream*);
	static char *analyzefile(Nlppp*,RFASem*,RFASem*,char*,ostream*);
	static char *analyzefile(Nlppp*,char*,char*,RFASem*,ostream*);
	static char *analyzefile(Nlppp*,char*,RFASem*,RFASem*,ostream*);
	static char *analyzefile(Nlppp*,RFASem*,char*,RFASem*,ostream*);
	static char *analyzefile(Nlppp*,RFASem*,RFASem*,RFASem*,ostream*);
	static char *analyzefile(Nlppp*,char*,char*,char*,RFASem*);
	static char *analyzefile(Nlppp*,char*,RFASem*,char*,RFASem*);
	static char *analyzefile(Nlppp*,RFASem*,char*,char*,RFASem*);
	static char *analyzefile(Nlppp*,RFASem*,RFASem*,char*,RFASem*);
	static char *analyzefile(Nlppp*,char*,char*,RFASem*,RFASem*);
	static char *analyzefile(Nlppp*,char*,RFASem*,RFASem*,RFASem*);
	static char *analyzefile(Nlppp*,RFASem*,char*,RFASem*,RFASem*);
	static char *analyzefile(Nlppp*,RFASem*,RFASem*,RFASem*,RFASem*);

	// Run another analyzer on a text string.
	// Grab outputs by the analyzer to the cbuf text buffer.
	// Args: analyzer_str, input_buf, datum_str, ostream.
	static char *analyzebuf(Nlppp*,char*,char*,char*,ostream*);
	static char *analyzebuf(Nlppp*,char*,RFASem*,char*,ostream*);
	static char *analyzebuf(Nlppp*,RFASem*,char*,char*,ostream*);
	static char *analyzebuf(Nlppp*,RFASem*,RFASem*,char*,ostream*);
	static char *analyzebuf(Nlppp*,char*,char*,RFASem*,ostream*);
	static char *analyzebuf(Nlppp*,char*,RFASem*,RFASem*,ostream*);
	static char *analyzebuf(Nlppp*,RFASem*,char*,RFASem*,ostream*);
	static char *analyzebuf(Nlppp*,RFASem*,RFASem*,RFASem*,ostream*);
	static char *analyzebuf(Nlppp*,char*,char*,char*,RFASem*);
	static char *analyzebuf(Nlppp*,char*,RFASem*,char*,RFASem*);
	static char *analyzebuf(Nlppp*,RFASem*,char*,char*,RFASem*);
	static char *analyzebuf(Nlppp*,RFASem*,RFASem*,char*,RFASem*);
	static char *analyzebuf(Nlppp*,char*,char*,RFASem*,RFASem*);
	static char *analyzebuf(Nlppp*,char*,RFASem*,RFASem*,RFASem*);
	static char *analyzebuf(Nlppp*,RFASem*,char*,RFASem*,RFASem*);
	static char *analyzebuf(Nlppp*,RFASem*,RFASem*,RFASem*,RFASem*);

	// Load an analyzer into memory.
	static char *loadanalyzer(Nlppp*,char*);
	static char *loadanalyzer(Nlppp*,RFASem*);

	// Unload an analyzer from memory.
	static bool unloadanalyzer(Nlppp*,char*);
	static bool unloadanalyzer(Nlppp*,RFASem*);

};



#endif
/*************************      END OF FILE      ******************************/
